use os;
use uo;

const MAX_AMOUNT_TO_WITHDRAW	:= 600000;
const MIN_AMOUNT_TO_CHECK	:= 5000;
const MAX_AMOUNT_TO_CHECK	:= 1000000;

// Added by shaDoze
// Speech command functions
function Balance( npc, who )

	var myAmount := 0;
	foreach item in EnumerateItemsInContainer( FindBankBox( who ) )
		if( item.objtype == 0xEED )		// Money
			myAmount := myAmount + item.amount;
		elseif( item.objtype == 0xA410 )	// Checks
			myAmount := myAmount + CInt( GetObjProperty( item, "value" ) );
		endif
	endforeach


	// Maybe use 'Say' to say it in public.
	if( myAmount > 0 )
		PrintTextAbovePrivate( npc, "Thy current bank balance is " + myAmount + " gold.", who );
	else
		PrintTextAbovePrivate( npc, "Thou hast no gold in thy bank box.", who );
	endif

endfunction

function Withdraw( npc, who )

	var amount := CInt( RequestInput( who, who.backpack, "How much would you like to withdraw?" ) );

	if( !amount )
		SendSysMessage( who, "Cancelled." );
		return;
	elseif( amount <= 0 )
		PrintTextAbovePrivate( npc, "I'm sorry but I need to know how much you want to withdraw.", who );
		return;
	elseif( amount > MAX_AMOUNT_TO_WITHDRAW )
		PrintTextAbovePrivate( npc, "Thou canst not withdraw so much at one time!", who );
		return;
	endif

	var bankbox := FindBankBox( who );
	var missing := 0;

	if( ConsumeSubstance( bankbox, 0xEED, amount ) )
		if( amount <= 60000 )
			if( !CreateItemInBackpack( who, 0xEED, amount ) )
				missing := missing + amount;
			endif
		else
			var stacks	:= CInt( amount / 60000 );
			var rest	:= CInt( amount % 60000 );
			var i;
			for( i := 0; i < stacks; i := i + 1 )
				if( !CreateItemInBackpack( who, 0xEED, 60000 ) )
					missing := missing + 60000;
				endif
			endfor
			if( !CreateItemInBackpack( who, 0xEED, rest ) )
				missing := missing + rest;
			endif
		endif

		if( missing > 0 )
			PrintTextAbovePrivate( npc, "Thou hast withdrawn " + ( amount - missing ) + " gold from thy account.", who );
			SendSysMessage( who, "Your backpack is full. A check of the missing " + missing + " is placed in your bank box." );

			var bankCheck := CreateItemInContainer( bankbox, 0xA410, 1 );
			SetObjProperty( bankCheck, "value", missing );
			SetObjProperty( bankCheck, "ownerName", who.name );
			SetObjProperty( bankCheck, "ownerSerial", who.serial );
			bankCheck.name := "a bank check [" + missing + "]";
		else
			PrintTextAbovePrivate( npc, "Thou hast withdrawn " + amount + " gold from thy account.", who );
		endif
	else
		PrintTextAbovePrivate( npc, "Ah, art thou trying to fool me? Thou hast not so much gold!", who );
	endif

endfunction

function WriteCheck( npc, who )

	var amount := CInt( RequestInput( who, who.backpack, "How much would you like to check?" ) );

	if( !amount )
		SendSysMessage( who, "Cancelled." );
		return;
	elseif( amount <= 0 )
		PrintTextAbovePrivate( npc, "I'm sorry but I need to know how much you want to check.", who );
		return;
	elseif( amount > MAX_AMOUNT_TO_CHECK )
		PrintTextAbovePrivate( npc, "Our policies prevent us from creating checks worth that much!", who );
		return;
	elseif( amount < MIN_AMOUNT_TO_CHECK )
		PrintTextAbovePrivate( npc, "We cannot create checks for such a paltry amount of gold!", who );
		return;
	endif

	var bankbox := FindBankBox( who );
	var bankCheck := CreateItemInContainer( bankbox, 0xA410, 1 );

	if( !bankCheck )
		PrintTextAbovePrivate( npc, "There's not enough room in your bankbox for the check!", who );
		DestroyItem( bankCheck ); // Shouldn't be created anyway, but it's POL!
		return;
	endif

	if( ConsumeSubstance( bankbox, 0xEED, amount ) )
		SetObjProperty( bankCheck, "value", amount );
		SetObjProperty( bankCheck, "ownerName", who.name );
		SetObjProperty( bankCheck, "ownerSerial", who.serial );

		bankCheck.name := "a bank check [" + amount + "]";

		PrintTextAbovePrivate( npc, "Into your bank box I have placed a check in the amount of: " + amount, who );
	else
		PrintTextAbovePrivate( npc, "Ah, art thou trying to fool me? Thou hast not so much gold!", who );
		DestroyItem( bankCheck );
	endif

endfunction