include "NPC_Spells";

function Cast_Spell( caster, victim, spell_list )
var spell := lower(spell_list[RandomInt(spell_list.size()+1)]);

case( lower(spell) )
      "clumsy":                    if ( precastCheck( caster, victim, 1, 1 )) cast_clumsy( caster, victim ); endif
      "feeblemind":                if ( precastCheck( caster, victim, 3, 1 )) cast_feeblemind( caster, victim ); endif
      "heal":                      if ( precastCheck( caster, victim, 4, 1 )) cast_heal( caster, victim ); endif
      "magicarrow":                if ( precastCheck( caster, victim, 5, 1 )) cast_magicarrow( caster, victim ); endif
      "reactivearmor":             if ( precastCheck( caster, victim, 7, 1 )) cast_reactivearmor( caster, victim ); endif
      "weaken":                    if ( precastCheck( caster, victim, 8, 1 )) cast_weaken( caster, victim ); endif
      "agility":                   if ( precastCheck( caster, victim, 9, 2 )) cast_agility( caster, victim ); endif
      "cunning":                   if ( precastCheck( caster, victim, 10, 2 )) cast_cunning( caster, victim ); endif
      "cure":                      if ( precastCheck( caster, victim, 11, 2 )) cast_cure( caster, victim ); endif
      "harm":                      if ( precastCheck( caster, victim, 12, 2 )) cast_harm( caster, victim ); endif
      "protection":                if ( precastCheck( caster, victim, 15, 2 )) cast_protection( caster, victim ); endif
      "strength":                  if ( precastCheck( caster, victim, 16, 2 )) cast_strength( caster, victim ); endif
      "bless":                     if ( precastCheck( caster, victim, 17, 3 )) cast_bless( caster, victim ); endif
      "fireball":                  if ( precastCheck( caster, victim, 18, 3 )) cast_fireball( caster, victim ); endif
      "poison":                    if ( precastCheck( caster, victim, 20, 3 )) cast_poison( caster, victim ); endif
      "teleport":                  if ( precastCheck( caster, victim, 22, 3 )) cast_teleport( caster, victim ); endif
      "archcure":                  if ( precastCheck( caster, victim, 25, 4 )) cast_archcure( caster, victim ); endif
      "archprotection":            if ( precastCheck( caster, victim, 26, 4 )) cast_archprotection( caster, victim ); endif
      "curse":                     if ( precastCheck( caster, victim, 27, 4 )) cast_curse( caster, victim ); endif
      "greaterheal":               if ( precastCheck( caster, victim, 29, 4 )) cast_greaterheal( caster, victim ); endif
      "lightning":                 if ( precastCheck( caster, victim, 30, 4 )) cast_lightning( caster, victim ); endif
      "manadrain":                 if ( precastCheck( caster, victim, 31, 4 )) cast_manadrain( caster, victim ); endif
      "dispelfield":               if ( precastCheck( caster, victim, 34, 5 )) cast_dispelfield( caster, victim ); endif
      "reflect":                   if ( precastCheck( caster, victim, 36, 5 )) cast_reflect( caster ); endif
      "mindblast":                 if ( precastCheck( caster, victim, 37, 5 )) cast_mindblast( caster, victim ); endif
      "paralyze":                  if ( precastCheck( caster, victim, 38, 5 )) cast_paralyze( caster, victim ); endif
      "dispel":                    if ( precastCheck( caster, victim, 41, 6 )) cast_dispel( caster, victim ); endif
      "energybolt":                if ( precastCheck( caster, victim, 42, 6 )) cast_energybolt( caster, victim ); endif
      "explosion":                 if ( precastCheck( caster, victim, 43, 6 )) cast_explosion( caster, victim ); endif
      "invisibility":              if ( precastCheck( caster, victim, 44, 6 )) cast_invisibility( caster, victim ); endif
      "masscurse":                 if ( precastCheck( caster, victim, 46, 6 )) cast_masscurse( caster, victim ); endif
      "reveal":                    if ( precastCheck( caster, victim, 48, 6 )) cast_reveal( caster, victim ); endif
      "chainlightning":            if ( precastCheck( caster, victim, 49, 7 )) cast_chainlightning( caster, victim ); endif
      "fstrike":                   if ( precastCheck( caster, victim, 51, 7 )) cast_flamestrike( caster, victim ); endif
      "manavampire":               if ( precastCheck( caster, victim, 53, 7 )) cast_manavampire( caster, victim ); endif
      "massdispel":                if ( precastCheck( caster, victim, 54, 7 )) cast_massdispel( caster, victim ); endif
      "meteorswarm":               if ( precastCheck( caster, victim, 55, 7 )) cast_meteor( caster, victim ); endif
      "polymorph":                 if ( precastCheck( caster, victim, 56, 7 )) cast_polymorph( caster ); endif
      "earthquake":                if ( precastCheck( caster, victim, 57, 8 )) cast_earthquake( caster ); endif
      "summonvortex":              if ( precastCheck( caster, victim, 58, 8 )) cast_summonvortex( caster ); endif
      "summonair":                 if ( precastCheck( caster, victim, 60, 8 )) cast_summonair( caster ); endif
      "summondaemon":              if ( precastCheck( caster, victim, 61, 8 )) cast_summondaemon( caster ); endif
      "summonearth":               if ( precastCheck( caster, victim, 62, 8 )) cast_summonearth( caster ); endif
      "summonfire":                if ( precastCheck( caster, victim, 63, 8 )) cast_summonfire( caster ); endif                                   
      "summonwater":               if ( precastCheck( caster, victim, 64, 8 )) cast_summonwater( caster ); endif
      "summonundead":              cast_summonskel( caster ); // No power words, mana drained directly inside function.
endcase
endfunction

function precastCheck( caster, cast_on, spellid, circle )
  var mana := GetVital(caster, "mana");
  var mananeeded;
  case(circle)
      1:   mananeeded :=   4;
      2:   mananeeded :=   6;
      3:   mananeeded :=   9;
      4:   mananeeded :=  11;
      5:   mananeeded :=  14;
      6:   mananeeded :=  20;
      7:   mananeeded :=  40;
      8:   mananeeded :=  50;
  endcase
  mananeeded := mananeeded * 100;
  if(mana < mananeeded)
    return 0;
  endif
  var npcdesc     := ReadConfigFile( "::npcdesc" );
  var elem        := npcdesc[caster.npctemplate];
  var saywords    := elem.saywords;
  if(!CheckLineOfSight( caster, cast_on ))
    return 0;
  endif
  if( saywords )
    SpeakPowerWords( caster, spellid );
  endif
  SetVital(caster, "Mana", ( mana - mananeeded ) );
  return 1;
endfunction