use basic;
use cfgfile;
use os;
use uo;

include "include/attributes";

var buyimage  := {0x211b, 0x211c, 0x2121, 0x2124, 0x211f, 0x2120, 0x2126, 0x20f6, 0x211a, 0x2123, 0x2125, 0x2122, 0x211e, 0x211d, 0x2119, 0x20e6, 0x2108, 0x2103, 0x2101, 0x2135, 0x2136, 0x2137, 0x2127};
var sellimage := {0xc9, 0xd9, 0xcc, 0xc8, 0xe2, 0xe4, 0x123, 0xdc, 0x06, 0xee, 0xcd, 0xe1, 0xd4, 0x05, 0xd6, 0xcf, 0xd1, 0xd8, 0xcb, 0xd2, 0xda, 0xdb, 0x124};

function sellanimal(player, npc)

  var storage:= FindStorageArea("Merchant Storage");
  var inv_fs := find_or_create_item(storage, npc.serial + " FS", 0x0e40);

  var i;
  PrinttextAbovePrivate(npc, "What pet would you like to sell?", player);
  var pet := Target(player);
  if((!pet) || (pet==""))
	SendSysMessage(player, "Cancelled.");
	return;
  endif
  var tempdata  := GetObjProperty(pet, "master");
  var summoned  := GetObjProperty(pet, "summoned");
  if(!tempdata)
	PrinttextAbovePrivate(npc, "I cannot buy that.", player);
	return;
  endif
  if((pet.script == "tamed") && (tempdata == player.serial) && (!summoned))
    var theitem;
	if((pet.objtype==0xd3) && (pet.color==0x02e6))
	  theitem := CreateItemInContainer(inv_fs, 0x20cf, 1);
	elseif(pet.objtype==0xd3)
	  theitem := CreateItemInContainer(inv_fs, 0x2118, 1);
	else
	  for(i:=1;i<=sellimage.size();i:=i+1)
		if(pet.objtype==sellimage[i])
		  theitem := CreateItemInContainer(inv_fs, buyimage[i], 1);
		  break;
		endif
	  endfor
	endif
    SetObjProperty(theitem, "ClearRestock", (ReadGameClock() + 1800));
	var buyamount := CInt(GetStrength(pet) / 2);
/*    var mygold := GetObjProperty(me, "MyGold");
    if(!mygold)
      mygold := 5000;
    endif
    mygold := mygold - buyamount;
    SetObjProperty(me, "MyGold", mygold); */
	PrinttextAbovePrivate(npc, pet.name + " is worth " + buyamount + "gp", player);
	SetObjProperty(pet, "guardkill", 1);
	MoveCharacterToLocation(pet, 5555, 1111, 0, MOVECHAR_FORCELOCATION);
	Damage(pet, GetHp(pet) + 10);
	CreateItemInBackpack(player, 0x0eed, buyamount);
	return;
  elseif((pet.graphic == CID_HUMAN_MALE) || (pet.graphic == CID_HUMAN_FEMALE) )
	PrinttextAbovePrivate(npc, "Do I look like an Inn Keeper?!", player);
  else
	PrinttextAbovePrivate(npc, "You could sell " + pet.name + " but that is not your pet.", player);
  endif
endfunction

function FixName(PetName)
	var Numbers := Array("0","1","2","3","4","5","6","7","8","9");
	var i;
	for (i := 1; i <= Len(Numbers); i := i + 1)
		PetName[Numbers[i]] := "";
	endfor
	return PetName;
endfunction

function Save_Pet_Data(ticket, pet)
  var tempdata;
  ticket.name := "Pet claim ticket for : " + pet.name + " - " + FixName(pet.npctemplate);
  SetObjProperty(ticket, "petserial", pet.serial);
  tempdata := pet.npctemplate;
  SetObjProperty(ticket, "pettemplate", tempdata);
/*  SetObjProperty(pet,"stabled", 1);
  SetObjProperty(pet,"amtdue", 0);
  SetObjProperty(pet,"days", 1);
  MoveCharacterToLocation(pet, mx, my, 0, MOVECHAR_FORCELOCATION);
  mystorage := mystorage + 1;
  SetObjProperty(me, "totalpets", mystorage); */
  SetObjProperty(pet, "guardkill", 1);
  MoveCharacterToLocation(pet, 5555, 1111, 0, MOVECHAR_FORCELOCATION);
  Damage(pet, GetHp(pet) + 10);
endfunction

function Load_Ticket_Data(player, ticket, npc)

  var pet_template := GetObjProperty(ticket, "pettemplate");
  
  if((pet_template == "AlreadyClaimed") or (!pet_template))
     var abuser := LogIt(player,pet_template);
     //PrinttextAbovePrivate(npc, "You will pay for this abuse!!!");
     return 0;
  endif

  if (!canclaim(player,pet_template))
    PrinttextAbovePrivate(npc, "You have no chance of controlling that!", player);
    return;
  endif

  if(ticket.objtype == 0x14f0)
    
    if( !pet_template )
	MoveItemToContainer(player.backpack, ticket);
    	PrinttextAbovePrivate(npc, "This ticket appears to be broken.", player);
    	return 0;
    endif
    
    SetObjProperty(ticket, "pettemplate", "AlreadyClaimed");
    DestroyItem(ticket);
    PrinttextAbovePrivate(npc, "Oh, let me find your pet for you. One moment, please.", player);
    sleep(1);
/*    tempdata := GetObjProperty(ticket, "petserial");
    var petlist := ListMobilesNearLocation(mx, my, 0, 8);
    foreach critter in petlist
      if(critter.serial == tempdata)
        pet := critter;
        break;
      endif
    endforeach
    if(!pet.serial)
      PrinttextAbovePrivate(npc, "Im sorry, but I dont have this pet,", player);
      sleep(1);
      PrinttextAbovePrivate(npc, "are you sure you stabled it with me?", player);
      return;
    endif
    var cost := GetObjProperty(pet, "amtdue");
    if(cost > 1)
      PrinttextAbovePrivate(npc, "you owe me " + (cost - 1) + " gold coins for extended care.", player);
      sleep(1);
      if(!GetPayment(player, (cost - 1)))
        PrinttextAbovePrivate(npc, "please come back when you can afford the boarding fees", player);
        return;
      endif
    endif */
    var pet := CreateNpcFromTemplate(pet_template,player.x,player.y,player.z);
    SetObjProperty(pet, "master", player.serial);
    SetObjProperty(pet, "prevtamed", 1);
    EraseObjProperty(pet,"stabled");
    EraseObjProperty(pet,"amtdue");
    EraseObjProperty(pet,"days");
	pet.script := "tamed";
    RestartScript(pet);
/*    MoveCharacterToLocation(pet, player.x, player.y, player.z, MOVECHAR_FORCELOCATION);
    mystorage := mystorage - 1;
    SetObjProperty(me, "totalpets", mystorage); */
    PrinttextAbovePrivate(npc, "Take care of " + pet.name + " and be sure to feed it!", player);
  endif
endfunction

function GetPayment(npc, player, price)
  var backpack := EnumerateItemsInContainer(player.backpack);
  var a := 0;
  foreach item in backpack
    if ((item.objtype == 0xeed) && (item.amount >= price) )
      if(SubtractAmount(item, price))
        a := 1;
        break;
      endif
    endif
  endforeach
  if(a == 1)
    return 1;
  else
    PrinttextAbovePrivate(npc, "You dont have " + price + " gold coins!", player);
    return 0;
  endif
endfunction

function canclaim(player, pettemplate)
  var conf := ReadConfigFile("::npcdesc");
  var elem;
  var points := 0;
  elem := FindConfigElem(conf, pettemplate);
  if (!elem)
    return 0;
  endif
  return 1;
endfunction

function stablepet(npc, player, pet)

  var tempdata := GetObjProperty(pet, "master");
  var summoned := GetObjProperty(pet, "summoned");
  if((pet.script == "tamed") && (!summoned))
	if (tempdata == player.serial)
		var price := 30 + (GetStrength(pet)/5);
                PrintTextAbovePrivate(npc,"I charge " + price + " to take care of " + pet.name + ".", player);
		if (GetPayment(npc, player, price))
			PrintTextAbovePrivate(npc, "Keep this ticket and give it to me when you want " + pet.name + " back.", player);
			var ticket := CreateItemInBackpack(player, 0x14f0, 1);
			ticket.usescript := "";
			Save_Pet_Data(ticket, pet);
		endif
	else
		PrintTextAbovePrivate(npc, "This is not a zoo!", player);
	endif
  elseif((pet.graphic == CID_HUMAN_MALE) || (pet.graphic == CID_HUMAN_FEMALE) )
	PrintTextAbovePrivate(npc, "Do I look like an Inn Keeper?!", player);
  else
	PrintTextAbovePrivate(npc, "That is not your pet.", player);
  endif

endfunction

Function LogIt(who, template)

    //ABUSER CONTROL SYSTEM
            var acct := who.acct;
            var cfg := ReadConfigFile("::Staff/stablebug");
            var elem:={ };
            elem.append({"Account",       acct.name});
            elem.append({"Name",       who.name});
            elem.append({"IP",       who.ip});
            elem.append({"Template",       template});
            AppendConfigFileElem("::Staff/stablebug", "Time", ReadGameClock(), elem);
            var unload := UnloadConfigFile("::Staff/stablebug");
    //END
  
Endfunction
