include "include/attributes";
include "include/client";
include "../pkg/foundations/gumps/gumps";

var skills:= GetSkillIds();
var skillbuttons:= {};
var skillids:= {};
var reducegump;
var maingump;

function Forget(who)
 
  fillskillids();
  var retval;

  repeat
    creategumps(who);
    retval:= showmaingump(who);
    if(retval <> -1)
      showreducegump(who,retval);
    endif 
  until(retval == -1);
 
endfunction


function creategumps(who);

  GFInitGump(0,0);
  GFNoClose();
  GFResizePic(0,0,BKGND_BLACKSLAB,640,480);
  GFResizePic(50,30,BKGND_STONESLAB,540,30);
  GFTextLine(100,35,0,"Select the skill you would like to reduce from the list below.");
  GFResizePic(30,70,BKGND_STONESLAB,400,22);
  GFResizePic(490,70,BKGND_STONESLAB,100,22);
  GFTextLine(50,71,0,"Attribute Name");
  GFTextMid(490,71,100,0,"%");
  GFResizePic(30,430,BKGND_STONESLAB,560,22);

  var okbutton:= GFButtonID(30,430,0x850,0x850,1);

  GFPage(1);

  var page:= 1;
  var j:= 0;
  var i;

  for(i:= 0; i < 49; i:= i + 1)
    if(j == 17)
      j:= 0;
      page:= page+1;
      GFButtonPage(600,430,0xFC,0xFD,page);
      GFPage(page);
      GFButtonPage(600,70,0xFA,0xFB,page - 1);
    endif 
    GFTextLine(50,91 + (j * 20),995,skillids[i + 1]);
    GFTextMid(490,91 + (j * 20),100,995,GetEffectiveSkill(who,skills[i + 1]) +"%");
    skillbuttons[i + 1]:= GFButtonID(30,94+(j*20),0x4B9,0x4BA,1);
    j:= j + 1;
  endfor

  page:= page+1;
  GFButtonPage(600,430,0xFC,0xFD,page);
  GFPage(page);
  GFButtonPage(600,70,0xFA,0xFB,page - 1);

  GFTextLine(50,91,995,"Strength");
  GFTextMid(490,91,100,995,GetAttribute(who,ATTRIBUTEID_STRENGTH));
  skillbuttons[i + 1]:= GFButtonID(30,94,0x4B9,0x4BA,1);
  GFTextLine(50,91 + 20,995,"Dexterity");
  GFTextMid(490,91 + 20,100,995,GetAttribute(who,ATTRIBUTEID_DEXTERITY));
  skillbuttons[i + 2]:= GFButtonID(30,94 + 20,0x4B9,0x4BA,1);
  GFTextLine(50,91 + 40,995,"Intelligence");
  GFTextMid(490,91 + 40,100,995,GetAttribute(who,ATTRIBUTEID_INTELLIGENCE));
  skillbuttons[i + 3]:= GFButtonID(30,94 + 40,0x4B9,0x4BA,1);
 
  maingump:= GFStoreGump();
 
endfunction


function showmaingump(who)
 
  var retval:= GFSendGumpV(who,maingump);
 
  var i;
 
  for(i:= 1; i <= 52; i:= i + 1)
    if(skillbuttons[i].keyid == retval[0])
      return i - 1;
      break;
    endif
  endfor

  return -1;

endfunction


function showreducegump(who,skillid)

  GFInitGump(0,0);
  GFNoClose();
  GFResizePic(0,0,BKGND_BLACKSLAB,640,320);
  GFResizePic(50,30,BKGND_STONESLAB,540,30);
  GFTextLine(70,35,0,"Select how much you would like to reduce your "+ skillids[skillid+1] +" skill by.");
  GFResizePic(30,70,BKGND_STONESLAB,580,70);
  GFTilePic(40,85,0xEEC);
  GFTilePic(50,90,0xEEF);
  GFTilePic(60,96,0xEF2);
  GFTilePic(38,115,0xEEE);
  GFTilePic(30,110,0xEED);
  GFTilePic(42,118,0xEF0);
  GFTextLine(120,95,0,"Free!");

  GFTextLine(40,150,995,"How much would you like to reduce your "+ skillids[skillid+1] +" skill by?");

  GFResizePic(30,270,BKGND_STONESLAB,580,22);

  var cancelbutton:= GFButtonID(555,270,0x847,0x848,1);
  var i; 
  var j:= 0;
  var k:= 0;
  var page:= 1;

  GFPage(page);

  var skillnums:= {};

  if(skillid < 49)
    for(i:= 1; i <= 100; i:= i + 1)
      if((k == 5) and (j == 4))
        k:= 0;
        j:= 0;
        page:= page + 1;
        GFButtonPage(600,235,0xFC,0xFD,page);
        GFPage(page);
        GFButtonPage(600,175,0xFA,0xFB,page - 1);
      endif
      if(j == 4)
        j:= 0;
        k:= k + 1;
      endif 
      GFTextLine(50 + (k * 100),175 + (j * 20),995,CStr(CDbl(i / 10.0)) +"%");
      skillnums[i + 1]:= GFButtonID(30 + (k * 100),179 + (j * 20),0x4B9,0x4BA,1);
      j:= j + 1;
    endfor
  else
    for(i:= 1; i <= 10; i:= i + 1)
      if((k == 5) and (j == 4))
        k:= 0;
        j:= 0;
        page:= page + 1;
        GFButtonPage(600,235,0xFC,0xFD,page);
        GFPage(page);
        GFButtonPage(600,175,0xFA,0xFB,page - 1);
      endif
      if(j == 4)
        j:= 0;
        k:= k + 1;
      endif 
      GFTextLine(50 + (k * 100),175 + (j * 20),995,i);
      skillnums[i + 1]:= GFButtonID(30 + (k * 100),179 + (j * 20),0x4B9,0x4BA,1);
      j:= j + 1;
    endfor
  endif

  var retval:= GFSendGump(who);

  if(skillid < 49)
    var newskill:= GetAttributeBaseValue(who,GetAttributeIdBySkillId(skillid)) - (retval.keys[2] - 1025);
    if(newskill < 0)
      newskill:= 0;
    endif
    SetAttributeBaseValue(who,GetAttributeIdBySkillId(skillid),newskill);
  else
    case(skillid)
      49: skillid:= ATTRIBUTEID_STRENGTH;
      50: skillid:= ATTRIBUTEID_DEXTERITY;
      51: skillid:= ATTRIBUTEID_INTELLIGENCE;
    endcase
    var newskill:= GetAttributeBaseValue(who,skillid) - ((retval.keys[2] - 1025) * 10);
    if(newskill < 100)
      newskill:= 100;
    endif
    SetAttributeBaseValue(who,skillid,newskill);
  endif

  return;

endfunction

function fillskillids()

   skillids[1] := "Alchemy";
   skillids[2] := "Anatomy";
   skillids[3] := "Animal Lore";
   skillids[4] := "Item Identification";
   skillids[5] := "Armslore";
   skillids[6] := "Parrying";
   skillids[7] := "Begging";
   skillids[8] := "Blacksmithy";
   skillids[9] := "Bowcraft/Fletching";
   skillids[10] := "Peacemaking";
   skillids[11] := "Camping";
   skillids[12] := "Carpentry";
   skillids[13] := "Cartography";
   skillids[14] := "Cooking";
   skillids[15] := "Detect Hidden";
   skillids[16] := "Enticement";
   skillids[17] := "Evaluate Intelligence";
   skillids[18] := "Healing";
   skillids[19] := "Fishing";
   skillids[20] := "Forensics";
   skillids[21] := "Herding";
   skillids[22] := "Hiding";
   skillids[23] := "Provocation";
   skillids[24] := "Inscription";
   skillids[25] := "Lockpicking";
   skillids[26] := "Magery";
   skillids[27] := "Magic Resistance";
   skillids[28] := "Tactics";
   skillids[29] := "Snooping";
   skillids[30] := "Musicianship";
   skillids[31] := "Poisoning";
   skillids[32] := "Archery";
   skillids[33] := "Spirit Speak";
   skillids[34] := "Stealing";
   skillids[35] := "Tailoring";
   skillids[36] := "Taming";
   skillids[37] := "Taste Identification";
   skillids[38] := "Tinkering";
   skillids[39] := "Tracking";
   skillids[40] := "Veterinary";
   skillids[41] := "Swordsmanship";
   skillids[42] := "Mace Fighting";
   skillids[43] := "Fencing";
   skillids[44] := "Wrestling";
   skillids[45] := "Lumberjacking";
   skillids[46] := "Mining";
   skillids[47] := "Meditation";
   skillids[48] := "Stealth";
   skillids[49] := "Remove Trap";
   skillids[50] := "Strength";
   skillids[51] := "Dexterity";
   skillids[52] := "Intelligence";

endfunction