use uo;
use cfgfile;

function MakeBleed(object, blood_color:=0)
	if ( GetObjProperty(object, "NoBlood") )
		return 0;
	elseif ( !blood_color )
		blood_color := CInt(GetObjProperty(object, "BloodColor"));
	endif
	
	if ( object.npctemplate )
		//Living NPC
		var npc_cfg := ReadConfigFile("::npcdesc");
		var npc_info := npc_cfg[object.npctemplate];
		if ( npc_info.NoBlood )
			//Does this npc bleed?
			return 0;
		else
			if ( !blood_color )
				//Does this npc have a special blood color?
				blood_color := CInt(npc_info.BloodColor);
			endif
		endif
	elseif ( object.IsA(POLCLASS_CORPSE) )
		//If it is a player corpse, then the CProp checks at the begining
		//of this function have taken care of what we need it to. However,
		//if it is an npc corpse, we need to check it as if it was an npc.
		if ( !object.PlayerCorpse() )
			var npc_info := GetObjProperty(object, "npc_info");
			var npc_cfg := ReadConfigFile("::npcdesc");
			npc_info := npc_cfg[npc_info.npctemplate];
			
			if ( npc_info.NoBlood )
				//Does this npc bleed?
				return 0;
			else
				if ( !blood_color )
					//Does this npc have a special blood color?
					blood_color := CInt(npc_info.BloodColor);
				endif
			endif
		endif
	endif
	
	var blood := CreateItemAtLocation(object.x, object.y, object.z, "blood", 1);
	blood.color := blood_color;
		
	return blood;
	
	return 0;
endfunction
		