use uo;
use os;

include "include/client";
include "include/attributes";
include "include/objtype";
include "include/spellRestrictions";

function custom_recall(caster, parms, book)
  caster.hidden := 0;
  if(GetMana(caster) < 11)
    caster.frozen :=1;
	PerformAction(caster,ANIM_CAST_DIR);
    sleepms(1200);
    caster.frozen :=0;
    SendSysMessage(caster,"you do not have enough mana to cast that");
    PlaySoundEffect(caster,0x005d);
    PlayObjectCenteredEffect(caster, 0x3735,0x0a, 0x1e);
    return 0;
  endif
  var failure := 0;
  var tox := parms[2];
  var toy := parms[3];
  var toz := parms[4];
  var oldx := caster.x;
  var oldy := caster.y;
  var oldz := caster.z;
  SpeakPowerWords( caster, 32 );

  var animals:= MoveAnimals(caster);
  var result := maincast(caster, "notarget", 4, "neutral", 32);
  if(result[1] == 0)
    return;
  endif

  var othersidecheck := CreateItemAtLocation(tox, toy, toz, 0xeed, 1);
  othersidecheck.hidden := 1;

  //Yaika'ar) Added to not be able to recall into dungeons.
  if( tox>=5120 and toy>=0 and tox<=6143 and toy<=2303 ) 
    SendSysmessage(caster, "The dungeon is too deep, it is impossible to recall there.");
    return 0;
  endif
  //Yaika'ar) Added to not be able to recall into NL2.
  if( tox>=5120 and toy>=3227 and tox<=6143 and toy<=4093 ) 
    SendSysmessage(caster, "You cannot recall to NL2.");
    return 0;
  endif

  if(othersidecheck.multi.serial)
  if(!book.newbie)
    SendSysMessage(caster, "Something is interfering with this spell.");
    DestroyItem(othersidecheck);
    return;
  endif
  endif

  DestroyItem(othersidecheck);
  var signs := ListItemsNearLocationOfType( tox, toy, toz, 30, 0x7060);
  foreach item in signs
      var infoarr := GetObjProperty( item, "homeinfo" );
    if (infoarr)
      if ((tox >= infoarr[2]) && (tox <= infoarr[4]) && (toy >= infoarr[3]) && (toy <= infoarr[5]))
        failure := 1;
      endif
    endif
  endforeach
  if (failure == 0); 
    SetObjProperty(caster, "noshag", ReadGameClock());
    MoveCharacterToLocation(caster, tox, toy, toz);
  else
    SendSysMessage(caster, "Something is interfering with this spell.");
    return 0;
  endif

    if(book.newbie)
	   var cown, friend;
       var coownerinfo := GetObjProperty(caster.multi,"coownlist");
       if(caster.acctname in coownerinfo)
         cown := 1;
       else
         var friendinfo := GetObjProperty(caster.multi,"friendlist");
         if(caster.acctname in friendinfo)
           friend := 1;
         endif
       endif
         
       var owneracct := GetObjProperty(caster.multi,"owneracct");
         
       if (GetObjProperty( caster.multi , "ownerserial" ) == caster.serial or cown or friend or owneracct == caster.acctname)
         SendSysmessage(caster, "Home sweet home...");
       else
         if(caster.multi);
           SendSysmessage(caster, "That was not your house and no one likes you there...");
		 else
           SendSysmessage(caster, "But there is no house there...");
         endif
	SetObjProperty(caster, "noshag", ReadGameClock());
         MoveCharacterToLocation( caster, oldx, oldy, oldz );
	     return;
       endif
     endif

    PlaySoundEffect(caster, 0x1fd);

	foreach animal in animals
	  MoveCharacterToLocation(SystemFindObjectBySerial(animal),tox,toy,toz);
	endforeach

  return 1;
endfunction

function custom_gate(caster, parms, book)
  caster.hidden := 0;
  if(GetMana(caster) < 40)
    caster.frozen :=1;
	PerformAction(caster,ANIM_CAST_DIR);
    sleepms(1200);
    caster.frozen :=0;
    SendSysMessage(caster,"You do not have enough mana to cast that.");
    PlaySoundEffect(caster,0x005d);
    PlayObjectCenteredEffect(caster, 0x3735,0x0a, 0x1e);
    return 0;
  endif
  var circle := 7;
  var tox := parms[2];
  var toy := parms[3];
  var toz := parms[4];
  SpeakPowerWords( caster, 52 );
  var delivery := "notarget";
  var noto := "neutral";
  var result := maincast(caster, delivery, circle, noto, 52);
  if(result == 0)
    return;
  endif

  var othersidecheck := CreateItemAtLocation(tox, toy, toz, 0xeed, 1);

  //Yaika'ar) Added to not be able to gate into dungeons.
  if( tox>=5120 and toy>=0 and tox<=6143 and toy<=2303 ) 
    SendSysmessage(caster, "You cannot open a gate to a dungeon.");
    return 0;
  endif
  //Yaika'ar) Added to not be able to gate into NL2.
  if( tox>=5120 and toy>=3227 and tox<=6143 and toy<=4093 )
    SendSysmessage(caster, "You cannot open a gate to NL2.");
    return 0;
  endif
  //Yaika'ar) Added to not be able to gate from dungeons.
  if( caster.x>=5120 and caster.y>=0 and caster.x<=6143 and caster.y<=2303 ) 
    SendSysmessage(caster, "You cant open a gate from a dungeon.");
    return 0;
  endif
  //Yaika'ar) Added to not be able to gate from NL2.
  if( caster.x>=5120 and caster.y>=3227 and caster.x<=6143 and caster.y<=4093 ) 
    SendSysmessage(caster, "You cannot open a gate from NL2.");
    return 0;
  endif

  othersidecheck.hidden := 1;
  if(othersidecheck.multi.serial)
    DestroyItem(othersidecheck);
    return;
  endif
  DestroyItem(othersidecheck);
  var signs := ListItemsNearLocationOfType( tox, toy, toz, 30, 0x7060);
  var chk := 0;
  foreach item in signs
    var infoarr := GetObjProperty(item, "homeinfo");
    if(infoarr)
      if((tox >= infoarr[2]) && (tox <= infoarr[4]) && (toy >= infoarr[3]) && (toy <= infoarr[5]))
        chk := 1;
        break;
      endif
    endif
  endforeach
  if(chk == 1)
    return;
  endif
  set_critical( 1 );
  var gate1 := CreateItemAtLocation(caster.x, caster.y, caster.z, UOBJ_BLUE_MOONGATE, 1);
  gate1.movable := 0;
  var gate2 := CreateItemAtLocation(tox, toy, toz, UOBJ_BLUE_MOONGATE, 1);
  gate2.movable := 0;
  if (!gate1 || !gate2)
    return;
  endif
  SetObjProperty( gate1, "GateDestX", gate2.x );
  SetObjProperty( gate1, "GateDestY", gate2.y );
  SetObjProperty( gate1, "GateDestZ", gate2.z );
  SetObjProperty( gate2, "GateDestX", gate1.x );
  SetObjProperty( gate2, "GateDestY", gate1.y );
  SetObjProperty( gate2, "GateDestZ", gate1.z );
  Detach();
  set_critical( 0 );

  // by DeiviD
  if(CheckGuarded(gate1))
    if(!CheckGuarded(gate2))
      SetObjProperty( gate2, "OtherGuarded", 1);
	endif
  endif
  if(CheckGuarded(gate2))
    if(!CheckGuarded(gate1))
      SetObjProperty( gate1, "OtherGuarded", 1);
	endif
  endif
  if(gate1.multi)
      SetObjProperty( gate2, "OtherMulti", 1);
  endif
  if(gate2.multi)
      SetObjProperty( gate1, "OtherMulti", 1);
  endif

  if ( gate1.x>=5120 and gate1.y>=0 and gate1.x<=6143 and gate1.y<=2303) // if dungeon
     SetObjProperty( gate1, "InsideDungeon", 1);
	 SetObjProperty( gate1, "Outgateid", gate2.serial);
	 SetObjProperty( gate2, "OutsideDungeon", 1);
  elseif ( gate2.x>=5120 and gate2.y>=0 and gate2.x<=6143 and gate2.y<=2303) // if dungeon
     SetObjProperty( gate2, "InsideDungeon", 1);
	 SetObjProperty( gate2, "Outgateid", gate1.serial);
	 SetObjProperty( gate1, "OutsideDungeon", 1);
  endif

// till here

  PlaySoundEffect( caster, SFX_SPELL_GATE_TRAVEL );
  sleep(30);
  set_critical(1);
  DestroyItem( gate1 );
  DestroyItem( gate2 );
  set_critical(0);
  return(1);
endfunction

function MoveAnimals(me)

  var newarray:= array;

  foreach animal in ListMobilesInLineOfSight(me,5)
    if((animal.script == "tamed") and (GetObjProperty(animal,"master") == me.serial))
      newarray.append(animal.serial);
    endif
  endforeach

  return newarray;

endfunction

function CheckGuarded(gate)		// Added by deivid for the gate delay
var gzone:= ReadConfigFile("::gzone");

  var entries:= GetConfigStringKeys(gzone);
  var guardzone:= 0;
  var range;
  var editedGzones := getglobalproperty("editedGzones");
  foreach listing in entries
    range := SplitWords(gzone[listing].range);
    if((gate.x >= CInt(range[1])) && (gate.x <= CInt(range[3])) && (gate.y >= CInt(range[2])) && (gate.y <= CInt(range[4])))
      //if (who.cmdlevel) sendsysmessage(who,"Your current guard zone is currently: " + listing); endif
      if ((gzone[listing].Guarded) && (editedGzones[_listing_iter]) == 1)
        guardzone:= 0;
      elseif ((!gzone[listing].Guarded) && (editedGzones[_listing_iter]) == 1)
        guardzone:= 1;
      elseif (gzone[listing].Guarded) 
        guardzone := 1;
      else
	guardzone := 0;
    
      endif
    endif
  endforeach

  return guardzone;

endfunction
