/**
 * ( lootable.inc )
 *
 * Functions used by custom loot script.
 *
 * by shaDoze, 2003
 * Designed for POL 0.95
 *
 * Email: shadoze@gmx.net
 * Last revision: 26 february 2003.
 */

use uo;
use os;

const MOBILE_CRIMINAL		:= 1;
const MOBILE_MURDERER		:= 2;
const MOBILE_INNOCENT		:= 3;

/**
 * Main program.
 */
function isLootable( corpse, looter )

	if( CInt( GetObjProperty( corpse, "serial" ) ) == looter.serial )
		// Player loots his own corpse
		return 1;
	endif

	var corpse_guild_id	:= GetObjProperty( corpse, "guild_id" );
	if(!corpse_guild_id)
	  return 0;
	endif

	var corpse_guild	:= FindGuild( corpse_guild_id );
	var looter_guild_id	:= GetObjProperty( looter, "guild_id" );
    if(!looter_guild_id)
	  return 0;
	endif
	var looter_guild	:= FindGuild( looter_guild_id );

	if( ( corpse_guild_id ) && ( looter_guild_id ) )
		// Player was in a guild
		if( ( corpse_guild_id == looter_guild_id ) ||
		    ( corpse_guild.isallyguild( looter_guild ) ) ||
		    ( corpse_guild.isenemyguild( looter_guild ) )
		)
			// Player is either in the same guild, an allied guild, or a warred guild
			return 1;
		endif
	endif


	return 0;

endfunction 


function getCorpseFlag( corpse )

	return CInt( GetObjProperty( corpse, "flaggings" ) );

endfunction


function setCorpseFlag( corpse, flag )

	SetObjProperty( corpse, "flaggings", CInt( flag ) );

endfunction