/**
 * ( LootPolicy.inc )
 *
 * by shaDoze, 2004
 * Designed for Neverlands, POL 0.95
 *
 * Email: shadoze@gmx.net
 * Last revision: 25 january 2004.
 */

use os;
use uo;

const BUTTON_IMAGE		:= 0x0988;
const GLOBAL_LOOT_POLICY_VAR	:= "LootPolicyActive";
const GLOBAL_LOOT_AREAS_VAR	:= "LootPolicyAreas";

function isInActiveLootArea( object )

	if( CInt( GetGlobalProperty( GLOBAL_LOOT_POLICY_VAR ) ) != 1 )
		return 0;
	endif

	var areas := {};
	areas := GetGlobalProperty( GLOBAL_LOOT_AREAS_VAR );

	if( !areas )
		return 0;
	endif

	foreach area in areas
		if( object.x >= area[1] && object.x <= area[3] && object.y >= area[2] && object.y <= area[4] )
			return 1;
		endif
	endforeach

	return 0;

endfunction

function changePolicy( who )

	var lootPolicyActive := CInt( GetGlobalProperty( GLOBAL_LOOT_POLICY_VAR ) );
	var action;

	if( lootPolicyActive == 1 )
		SetGlobalProperty( GLOBAL_LOOT_POLICY_VAR, 0 );
		action := "disabled";
	else
		SetGlobalProperty( GLOBAL_LOOT_POLICY_VAR, 1 );
		action := "enabled";
	endif

	SendSysMessage( who, "Looting policy is now " + action + "." );

endfunction

function clearAreas( who )

	var areas := {};

	SetGlobalProperty( GLOBAL_LOOT_AREAS_VAR, areas );

	SendSysMessage( who, "All areas have been deleted." );

endfunction

function deleteArea( who, index )

	var areas := {};
	areas := GetGlobalProperty( GLOBAL_LOOT_AREAS_VAR );

	if( !areas )
		return;
	endif

	areas.erase( index );
	SetGlobalProperty( GLOBAL_LOOT_AREAS_VAR, areas );

	SendSysMessage( who, "Area has been deleted." );

endfunction

function addArea( who, xStart, yStart, xEnd, yEnd, name )

	var areas := {};
	areas := GetGlobalProperty( GLOBAL_LOOT_AREAS_VAR );

	var area := { xStart, yStart, xEnd, yEnd, name };

	if( !areas )
		areas := { area };
	else
		areas.append( area );
	endif

	SetGlobalProperty( GLOBAL_LOOT_AREAS_VAR, areas );

	SendSysMessage( who, "Area has been added." );

endfunction