/////////////////////////////////////////////////////////////////////////////
//
//	fumble.inc
//
//	caine 14/10/2000:	first release
//	caine 28/10/2000:	changed fumble_check to take into acc. tgt stealskill
//
//
/////////////////////////////////////////////////////////////////////////////

use os;
use npc;
use cfgfile;

include "include/eventID";
include "include/findCity";

function fumble_check( who ) // do i fumble?
	
	var skill := ( GetAttribute( who, "Stealing" ) );
	var skill_neg := cint((skill - randomint(skill) - FUMBLE_RATE));
	
	//print("skill_neg := " + skill_neg); //debug
	if ( randomint(skill) >= skill_neg ) // fumble based on skill alone....
		return(1); // he did fumble
	else
		return(0); // he didnt
	endif
endfunction

function fumble( who, tgt, howbad := 0 )
	var skill := ( GetAttribute( who, "Stealing" ) );
	var tgtskill := ( GetAttribute( tgt, "Stealing" ) );
	
	if ( skill <= tgtskill )
		if ( randomint(100) > 90 )
			howbad := 1;
		endif
	endif
	
	if ( (randomint(10) <= FUMBLE_DEGREE) and ( !howbad ) )
		howbad := 1;
	endif
	
	if ( howbad == 0 )
		messup( who, tgt );
	else  //you screwed it up, and are now in shyte
		messup_bad( who, tgt );
	endif
	
endfunction

function messup( who, tgt ) // just a screw up, still a chance of a biggie though
	
	var skill := ( GetAttribute( who, "Stealing" ) );
	var random_number_100 := randomint(100); // more for debug than anything else
		
	//print(random_number_100); //debug
	//print(skill - 20); //debug
	//print(tgt.intelligence /2); //debug
	
	if (  (random_number_100 >= (GetAttribute( tgt, "Intelligence" ) / 2 )) and (random_number_100 <= (skill - 20)) )
		SendSysmessage (who, "You fumbled the theft, but thanks to your skill, it goes unnoticed...");
			
	elseif ( (who.hidden == 0) and (random_number_100 >= (GetAttribute( tgt, "Intelligence" ) / 2)) )
		SendSysmessage (who, "You fumbled the theft, and may have alerted your victim!");
		if ( randomint(100) >= skill )
			//print("alerted by message"); //debug
			Printtextaboveprivate( tgt, "You think you feel something, but you can't be sure.", tgt );
		endif
	elseif ( (who.hidden == 1) and (random_number_100 >= (GetAttribute( tgt, "Intelligence" ) / 2) )  )
		SendSysmessage (who, "You fumbled the theft, may have alerted your victim, and have been revealed!");
		who.hidden := 0;
		if ( randomint(100) >= skill )
			//print("alerted by message"); //debug
			Printtextaboveprivate( tgt, "You think you feel something, but you can't be sure.", tgt );
		endif
	else
		messup_bad( who, tgt );
	endif
endfunction

function messup_bad( who, tgt ) // make the thief pay....
	
	who.hidden := 0;

	var whoguild:= FindGuild(GetObjProperty(who,"guild_id"));
	var tgtguild:= FindGuild(GetObjProperty(tgt,"guild_id"));

	if((!tgt.criminal) and (!whoguild.isenemyguild(tgtguild)) and (!whoguild.isallyguild(tgtguild)))
		who.SetCriminal(1);
	endif

	SendSysmessage (who, "You fumble the theft, and alert your victim!");
	
//	var city:= FindCity(who);
	PrintTextAbove( tgt, "STOP! " + who.name + ", you thief!!");
	SendSysmessage( tgt, "You catch " + who.name + " trying to steal from you!");
	return;
endfunction