/////////////////////////////////////////////////////////////////////////////
//
//	text.inc
//
//	Author: Caine
//	Date:	22/10/2000 - work in progress
//
//	Description:	Text manipulation library
//			Current Functions :
//		22/10/2000:	function t_left( text, new_length := 1 )
//		22/10/2000:	function t_remright( text, new_length := 1 )
//		22/10/2000:	function t_right( text, new_length := 1 )
//		22/10/2000:	function t_remleft( text, new_length := 1 )
//		22/10/2000:	function t_mid( text, start := 1, finish := 1 )
//		22/10/2000:	function t_reverse ( text )
//		22/10/2000:	function t_in ( word, text, case_sense := 0, detail_search := 1 )
//
//	Notes:		Requires the basic.em (splitwords func)
//			i haven't got a round to writing my own yet.
//			
//	Dependencies: 	function t_in 
//				-> Requires Splitwords 			-> 	basic.em
//			
//	caine 22/10/2000:	Created and used for the first time
//
//	BUGS:		None that i've found just yet ;)
//
//
/////////////////////////////////////////////////////////////////////////////

use basic;

/////////////////////////////////////////////////////////////////////
//
// 	function returns the string, shortened FROM the LEFT
//
// eg. t_left( "Hello World!", 4 ) = "Hell"
//
/////////////////////////////////////////////////////////////////////
function t_left( text, new_length := 1 )
	
	var i := 1;
	var ret_str := "";
	
//////////////////////////////////////////////////////////////////
//		start -	ERROR CHECKING				//
//////////////////////////////////////////////////////////////////

	if ( len(text) = 1 )
		return(text);
	endif
	
	if ( (len(text) <= 0) )
		print( "t_left : !Error in text length!" );
		return(text);
	endif  

	if ( new_length < 1 )
		new_length := 1;
		print( "t_left : !Warning - new_length invalid error, setting to 1!" );
	elseif ( (new_length > len(text)) )
		print( "t_left : !Warning - new_length invalid error, setting to text length!" );
		new_length := len(text);
	endif

//////////////////////////////////////////////////////////////////
//		end - ERROR CHECKING				//
//////////////////////////////////////////////////////////////////
	
	for ( i := 1; i <= new_length; i := i + 1)
		ret_str := ret_str + text[i];
	endfor
	
	return(ret_str);

endfunction

/////////////////////////////////////////////////////////////////////
//
// 	function returns a string a FROM the left, a certain amount from the right. 
//
// NOTE: this is almost exactly the same as the t_left. The same results can be achived via t_left.
//	 but i was having so much fun... i just couldn't stop ;)
//
// eg. t_remright( "Hello World!", 4 ) = "Hello Wo"
//
/////////////////////////////////////////////////////////////////////
function t_remright( text, new_length := 1 )
	
	new_length := (len(text) - new_length);	
	var i := 1;
	var ret_str := "";
	
//////////////////////////////////////////////////////////////////
//		start -	ERROR CHECKING				//
//////////////////////////////////////////////////////////////////
	if ( len(text) == 1 )
		return(text);
	endif
	
	if ( (len(text) <= 0) )
		print( "t_remright : !Error in text length!" );
		return(text);
	endif  

	if ( new_length < 1 )
		new_length := 1;
		print( "t_remright: !Warning - new_length invalid error, setting to 1!" );
	elseif ( (new_length > len(text)) )
		print( "t_remright: !Warning - new_length invalid error, setting to text length!" );
		new_length := len(text);
	endif

//////////////////////////////////////////////////////////////////
//		end - ERROR CHECKING				//
//////////////////////////////////////////////////////////////////
	
	for ( i := 1; i <= new_length; i := i + 1)
		ret_str := ret_str + text[i];
	endfor
	
	return(ret_str);

endfunction

/////////////////////////////////////////////////////////////////////
//
// 	function returns the string, shortened FROM the RIGHT
//
// eg. t_right( "Hello World!", 4 ) = "rld!"
//
/////////////////////////////////////////////////////////////////////
function t_right( text, new_length := 1 )
	
	new_length := (len(text) - new_length) + 1;
	var i := new_length;
	var ret_str := "";
	
//////////////////////////////////////////////////////////////////
//		start -	ERROR CHECKING				//
//////////////////////////////////////////////////////////////////

	if ( (len(text) <= 0) )
		print( "t_right : !Error in text length!" );
		return(text);
	endif  

	if ( len(text) = 1 )
		return(text);
	endif
	
	if ( new_length < 1 )
		new_length := 1;
		print( "t_right : !Warning - new_length invalid error, setting to text length!" );
	elseif ( (new_length > len(text)) )
		print( "t_right : !Warning - new_length invalid error, setting to 1!" );
		new_length := len(text);
	endif

//////////////////////////////////////////////////////////////////
//		end - ERROR CHECKING				//
//////////////////////////////////////////////////////////////////
	
	for ( i := new_length; i <= len(text); i := i + 1)
		ret_str := ret_str + text[i];
	endfor
	
	return(ret_str);

endfunction

/////////////////////////////////////////////////////////////////////
//
// 	function returns a string a FROM the right, a certain amount from the left. 
//
// NOTE: this is almost exactly the same as the t_right. The same results can be achived via t_right.
//	 but i was having so much fun... i just couldn't stop ;) again.
//
// eg. t_remleft( "Hello World!", 4 ) = "o World!"
//
/////////////////////////////////////////////////////////////////////
function t_remleft( text, new_length := 1 )
	
	new_length := new_length + 1;
	var i := new_length;
	var ret_str := "";
	
//////////////////////////////////////////////////////////////////
//		start -	ERROR CHECKING				//
//////////////////////////////////////////////////////////////////

	if ( (len(text) <= 0) )
		print( "t_remleft : !Error in text length!" );
		return(text);
	endif  

	if ( len(text) = 1 )
		return(text);
	endif
	
	if ( new_length < 1 )
		new_length := 1;
		print( "t_remleft : !Warning - new_length invalid error, setting to 1!" );
	elseif ( new_length > len(text) )
		print( "t_remleft : !Warning - new_length invalid error, setting to text length - 1!" );
		new_length := len(text);
	endif

//////////////////////////////////////////////////////////////////
//		end - ERROR CHECKING				//
//////////////////////////////////////////////////////////////////
	
	for ( i := new_length; i <= len(text); i := i + 1)
		ret_str := ret_str + text[i];
	endfor
	
	return(ret_str);

endfunction

/////////////////////////////////////////////////////////////////////
//
// 	function returns a string starting from a specified point and ending at a second specified point
//
// NOTE: if start is greater than finish... the string that is returned will be reversed.
//
// eg. t_mid( "Hello World!", 2, 6 ) = "llo Wo"
//	OR
//     t_mid( "Hello World!", 6, 2 ) = "oW oll"
//
/////////////////////////////////////////////////////////////////////
function t_mid( text, start := 1, finish := 1 )

	var i := 0;
	var ret_str := "";
	
//////////////////////////////////////////////////////////////////
//		start -	ERROR CHECKING				//
//////////////////////////////////////////////////////////////////

	if ( (len(text) <= 0) )
		print( "t_mid : !Error in text length!" );
		return(text);
	endif
	  
	if ( (start < 1) && (finish > len(text)) )
		print( "t_mid : !Warning - start & finish invalid error, setting to start to 1, finish to text length!" );
		start := 1;
		finish := len(text);
	elseif ( (finish < 1) && (start > len(text)) )
		print( "t_mid : !Warning - start & finish invalid error, setting to finish to 1, start to text length!" );
		finish := 1;
		start := len(text);
	endif

	if ( (start < 1) )
		start := 1;
		print( "t_mid : !Warning - start invalid error, setting to 1!" );
	endif
	
	if ( (finish < 1) )
		finish := 1;
		print( "t_mid : !Warning - finish invalid error, setting to 1!" );

	endif
	
	if ( (start > len(text)) )
		start := len(text);
		print( "t_mid : !Warning - start invalid error, setting to text length!" );
	endif
	
	if ( (finish > len(text)) )
		finish := len(text);
		print( "t_mid : !Warning - finish invalid error, setting to text length!" );
	endif
		
//////////////////////////////////////////////////////////////////
//		end - ERROR CHECKING				//
//////////////////////////////////////////////////////////////////

	if (start < finish)
		for ( i := start; i <= finish; i := i + 1)
			ret_str := ret_str + text[i];
		endfor
	elseif ( start > finish )
		for ( i := start; i >= finish; i := i - 1)
			ret_str := ret_str + text[i];
		endfor
	elseif ( start = finish )
		return(text[start]);
	else
		print( "t_mid : !Error midding text!" );
		return(text);
	endif
	
	return(ret_str);

endfunction

/////////////////////////////////////////////////////////////////////
//
// 	function returns the string, reversed 
//
// eg. t_reverse( "Hello World!" ) = "!dlroW olleH"
//
/////////////////////////////////////////////////////////////////////
function t_reverse ( text )

	var i := 1;
	var ret_str := "";
	
	if ( (len(text) <= 0) )
		print( "t_reverse : !Error in text length!" );
		return(text);
	endif
	  
	
	for ( i := len(text); i >= 1; i := i - 1)
		ret_str := ret_str + text[i];
	endfor
	
	return(ret_str);
endfunction


/////////////////////////////////////////////////////////////////////
// 	
//	function returns 1 if the word is found in the text
//
// NOTE: case_sense, if set to 1, takes the words Case into account
// 	 detail_search, if set to 1, does an indepth search for the word, 
//	 and is more likely to return the correct result than a quick search if there is punctuation.
//	 the quick search will search for an EXACT match ("WORLD!" != "WORLD")
//
// eg. t_in( "hello", "Hello World!" ) = 1
//	OR
//     t_in( "hello", "Hello World!", 1 ) = 0
//	OR
//     t_in( "hello", "Hello World!", 0, 0 ) = 1
//	OR
//     t_in( "World", "Hello World!" ,0 ,0) = 0  (the "!" is the problem, and detail mode is off)
//	OR
//     t_in( "world", "Hello World!" ) = 1
//
/////////////////////////////////////////////////////////////////////
function t_in ( word, text, case_sense := 0, detail_search := 1 )

	if ( !case_sense )
		word := lower(word);
		text := lower(text);
	endif
	
	var s_text := SplitWords( text );
	var i := 1;
	var j := 1;
	var t_len := len(s_text);
	
	//print("s_text := " + s_text ); //debug
	
	if ( t_len > 0 )
		if ( detail_search )
			for ( i := 1; i <= t_len; i := i + 1)
				if ( s_text[i] == word ) // do simple check first... if not equal, do detailed
					return(1);
				elseif ( t_remright(s_text[i],1) == word ) // using another function which may result in speed loss
					return(1); // word found... return 1
				endif
			endfor
		else
			for ( i := 1; i <= t_len; i := i + 1)
				if ( s_text[i] == word )
					return(1); // word found... return 1
				endif
			endfor
		endif
	endif
	
	return(0); // word not found... return 0
	
endfunction
