use uo;

include "include/canAccess";
include "../../skills/tinkering/magicjewel";

function recharge(who, charger)
//** There is no movable, reserved item, and accesible checks for charger because **
//** the checks are done already in the resmelt jewel, before this function is called **

  //Stop healing and meditation.
  EraseObjProperty(who, "HealTimer");
  EraseObjProperty(who, "IsMeditating");
  //Checks if the jewel is equipped...
  if(GetObjProperty(charger, "equipped"))
    SendSysMessage(who, "You cant use this jewel for recharging if you have it equipped.");
    return 0;
  endif
  //Checks if the jewel is identified...
  if(!GetObjProperty(charger, "IDed"))
    SendSysMessage(who, "You have to identify the jewel first.");
    return 0;
  endif
  //Set the charges if the jewel has no charges (only happends if pre-charges jewels was not quipped yet)...
  if(!GetObjProperty(charger, "charges"))
    setCharges(charger);
  endif

  //Ask to select the jewel to be recharged.
  SendSysMessage(who, "Select the magic jewel to recharge.");
  var charged := Target(who);

  //If the player canceled the target.
  if(!charged)
    SendSysMessage(who, "Cancelled.");
    return 0;
  endif
  //Checks if the item isnt accesible.
  if (!Accessible(who, charged))
    SendSysmessage(who, "You can't reach that.");
    return 0;
  endif
  //Checks if the item is too far away (max 3 tiles).
  if(Distance(who, charged) > 3)
    SendSysMessage(who, "The jewel is too far away.");
    return 0;
  endif
  var charger_skill := CInt(GetObjProperty(charger, "skill"));
  var charged_skill := CInt(GetObjProperty(charged, "skill"));
  var charged_skill_adj := CInt(GetObjProperty(charged, "skill_adj"));
  var charger_skill_adj := CInt(GetObjProperty(charger, "skill_adj"));
  //Checks if it is a magic jewel...
  if((!charged_skill_adj) || (charged_skill == "strength") || (charged_skill == "intelligence") || (charged_skill == "dexterity"))
    SendSysMessage(who, "That is not a magic jewel!");
    return 0;
  endif
  //Checks if the jewel is identified...
  if(!GetObjProperty(charged, "IDed"))
    SendSysMessage(who, "That jewel isnt identified yet.");
    return 0;
  endif
  //Checks if you target the same jewel used to recharge...
  if(charger.serial == charged.serial)
    SendSysMessage(who, "A magic jewel cannot recharge itself!");
    return 0;
  endif
  //Checks if you have the jewel equipped.
  if(GetObjProperty(charged, "equipped"))
    SendSysMessage(who, "You cant recharge this jewel if you have it equipped.");
    return 0;
  endif
  //Reserve the jewel. Stops if the jewel is being used (most likelly by someone else using it for recharging)...
  if(!ReserveItem(charged))
    SendSysMessage(who, "This magic jewel is already in use.");
    return 0;
  endif
  //Set the charges if the jewel has no charges (only happends if pre-charges jewels was not quipped yet)...
  if(!GetObjProperty(charged, "charges"))
    setCharges(charged);
  endif
  //If the jewels are of same type, check if they are better or equal.
  if((charged_skill_adj <= charger_skill_adj) && (charger_skill == charged_skill))
    SendSysMessage(who, "You cant recharge this with a higher or equal jewel if both affect the same skill.");
    return 0;
  endif
  var charger_charges := CInt(GetObjProperty(charger, "charges"));
  var charged_charges := CInt(GetObjProperty(charged, "charges"));
  var charges_multiplier;
  //Set the multiplier depending of the skill difference between them.
  var skill_adj_diff := CInt(charged_skill_adj - charger_skill_adj);

  //If the jewels are of the same skill...
  if(charger_skill == charged_skill)
    case(skill_adj_diff)
	5:  charges_multiplier := 0.75;
	10: charges_multiplier := 0.5;
	15: charges_multiplier := 0.25;
	20: charges_multiplier := 0.1;
    endcase
  else
    //If the jewels are of different skill, and the jewel to be recharged is lower or equal.
    if(charged_skill_adj <= charger_skill_adj)
      //Set the multiplier depending of the skill difference between them.
      var skill_adj_diff := CInt(charger_skill_adj - charged_skill_adj);
      case(skill_adj_diff)
        0:  charges_multiplier := 0.30;
	5:  charges_multiplier := 0.31;
	10: charges_multiplier := 0.32;
	15: charges_multiplier := 0.33;
	20: charges_multiplier := 0.35;
      endcase
    else
      //If the jewels are of different skill, and the jewel to be recharged is better.
      case(skill_adj_diff)
	5:  charges_multiplier := 0.23;
	10: charges_multiplier := 0.16;
	15: charges_multiplier := 0.10;
	20: charges_multiplier := 0.05;
      endcase
    endif
  endif
  //The charges to be transfered.
  var charged_max_trans := CInt(GetObjProperty(charged, "maxCharges"));
  var charger_transfer := CInt(charger_charges * charges_multiplier);
  var charged_transfer := CInt(charged_max_trans * charges_multiplier);

  var transfer_charges;
  if(charger_transfer <= charged_transfer)
    transfer_charges := charger_transfer;
  else
    transfer_charges := charged_transfer;
  endif

  //The new charges the jewel will have.
  var new_charges := CInt(charged_charges + transfer_charges);

  //Recharging gump.
  var suffix_1 := GetObjProperty(charger, "suffix");
  var suffix_2 := GetObjProperty(charged, "suffix");
  var name_1 := SplitWords(suffix_1);
  var name_2 := SplitWords(suffix_2);
  var skill_1;
  var skill_2;
  //The percentage of charges transfered.
  var multiplier := (transfer_charges * 1000) / charger_charges;
  multiplier := multiplier/10 + "." + CInt(multiplier - ((multiplier/10) * 10)); 
  //If the suffix of the jewel used to recharge has 2 words, set as name the 2nd one (1-word skill).
  if(len(name_1) == 2)
    skill_1 := name_1[2];
  else
    //otherwise, set as name the 2nd and 3rd word (2-words skill).
    skill_1 := name_1[2] + " " + name_1[3];
  endif
  //Do the same for the jewel to be recharged.
  if(len(name_2) == 2)
    skill_2 := name_2[2];
  else
    skill_2 := name_2[2] + " " + name_2[3];
  endif

  var layout := array(
		"page 0", 
		"nodispose 1",
		"resizepic 0 50 5170 295 400", //base gump.
		"gumppic 25 85 92", //red thing in the up-left.
		"gumppic 70 86 94", //the end of the red thing.
		"button 35 390 2130 2129 1 0 1", //Accept button
		"button 95 390 2119 2120 1 0 0", //Cancel button
		"text 75 93 1100 0", // Gump title
		"text 40 140 1175 1", 
		"text 40 165 1174 2", //Skill of jewel used to recharge
		"text 40 185 1174 3", //Charges of that jewel
		"text 40 220 1175 4",
		"text 40 245 1174 5", //Skill of jewel to be recharged
		"text 40 265 1174 6", //Charges of that jewel
		"text 40 300 1173 7", //% of charges transfered
		"text 40 320 1173 8", //Number of charges being transfered
		"text 40 365 1175 9" 
		);

  var data := array( 
		"Recharge system",
		"Jewel used to recharge:",
		"+" + charger_skill_adj + " " + skill_1,
		charger_charges + " charges", 
		"Jewel to be recharged:",
		"+" + charged_skill_adj + " " + skill_2,
		charged_charges + " charges",
		"Percentage transfered: " + multiplier + "%", 
		transfer_charges + " charges will be transfered",
		"Are you sure?"
		);

  var res := SendDialogGump(who, layout, data);
  if(!res)
    SendSysMessage(who, "Cancelled.");
    return 0;
  endif
  //Check if the jewel is not there for some reason (security).
  if(!charger)
    SendSysMessage(who, "Where is the jewel? Cancelled.");
    return 0;
  endif
  //Check if the jewel was destroyed correctly, and only then, adjust the charges of the recharged jewel (security).
  var destroy_check := DestroyItem(charger);
  if(destroy_check)
    SetObjProperty(charged, "charges", new_charges);
    SendSysMessage(who, "Done!");
  else
    SendSysMessage(who, "Failed to destroy the jewel. Cancelled.");
    return 0;
  endif
  //After recharging, adjust the name accordly.
  case (charged.graphic)
    4234: SetName(charged,"a " + getobjproperty(charged,"prefix") + " Ring " + GetObjProperty(charged,"suffix") + " [" + GetObjProperty(charged,"charges") + " charges]");
    4233: SetName(charged,"a " + getobjproperty(charged,"prefix") + " Necklace " + GetObjProperty(charged,"suffix") + " [" + GetObjProperty(charged,"charges") + " charges]");
    4229: SetName(charged,"a " + getobjproperty(charged,"prefix") + " Necklace " + GetObjProperty(charged,"suffix") + " [" + GetObjProperty(charged,"charges") + " charges]");
    4231: SetName(charged,"a " + getobjproperty(charged,"prefix") + " Earrings " + GetObjProperty(charged,"suffix") + " [" + GetObjProperty(charged,"charges") + " charges]");
    4232: SetName(charged,"a " + getobjproperty(charged,"prefix") + " Necklace " + GetObjProperty(charged,"suffix") + " [" + GetObjProperty(charged,"charges") + " charges]");
    4230: SetName(charged,"a " + getobjproperty(charged,"prefix") + " Bracelet " + GetObjProperty(charged,"suffix") + " [" + GetObjProperty(charged,"charges") + " charges]");
    default: SetName(charged,"a " + getobjproperty(charged,"prefix") + " item " + GetObjProperty(charged,"suffix") + " [" + GetObjProperty(charged,"charges") + " charges]");
  endcase
  return 1;
endfunction