use uo;
use util;
use math;
use os;
include "include/attributes";


const WEAPON_BALANCE := 1; //Yaika'ar) Used to balance things, so the damage of weapons is based on this var (default=1).
const PARRY_BALANCE := 2; //Used to balance parry, bigger number, more parried attacks (to be like distro, = 1).
var cfg := ReadConfigFile(":combat:itemdesc");

//Yaika'ar) Added this function so we can change easy the parrying power.
function ParryCheck(defender, basedamage)
  var parrybalance := PARRY_BALANCE / 2;
  var parry := CInt(GetEffectiveSkill(defender, SKILLID_PARRY) * parrybalance);
  if(RandomInt(parry) >= basedamage)
    return 1;
  else
    return 0;
  endif
endfunction


//Yaika'ar) Changed this function for the pvp balance system, so a contant was added that tweaks down or up weapons damage.
function DealDamage(defender, attacker, rawdamage)
  rawdamage := CInt(rawdamage * WEAPON_BALANCE);
  ApplyRawDamage(defender, rawdamage);
endfunction

function AdjustNoto(attacker, defender)
  if!(defender.dead)
	return 0;
  endif
  var karma := CInt(GetObjProperty(attacker, "Karma") );
  var fame := CInt(GetObjProperty(attacker, "Fame") );
  var vkarma := CInt(GetObjProperty(defender, "Karma") );
  var vfame := CInt(GetObjProperty(defender, "Fame") );
  var kmod := 1;
  fame := fame + CInt( (vfame / 10) / ( CInt(Log10(fame)) + 1 ) );
  if !(defender.npctemplate)
	vfame := CInt(vfame * 0.9);
  endif
  if((karma < -15) && (vkarma < -15))
	return;
  endif
  if(vkarma > 15)
	kmod := -1;
	karma := Abs(karma);
  else
	vkarma := Abs(vkarma);
  endif
  kmod := kmod * CInt( (vkarma / 10) / ( CInt(Log10(karma)) + 1 ) );
  karma := karma + kmod;
endfunction