Const TOWN_BRITAIN			:= 1;
Const TOWN_COVE			:= 2;
Const TOWN_JHELOM			:= 3;
Const TOWN_MAGINCIA			:= 4;
Const TOWN_MINOC			:= 5;
Const TOWN_MOONGLOW			:= 6;
Const TOWN_NUJELM			:= 7;
Const TOWN_OCLLO			:= 8;
Const TOWN_SERPENTS_HOLD		:= 9;
Const TOWN_SKARA_BRAE		:= 10;
Const TOWN_TRINSIC			:= 11;
Const TOWN_VESPER			:= 12;
Const TOWN_YEW				:= 13;

Const TOWN_START			:= 1;
Const TOWN_END				:= 13;




///////////////////
//  Figures out out if a location is within a town, and if so, what town
///////////////////

function FindTownFromLocation (x, y)
	if (x >= 1275 and x <= 1720 and y >= 1500 and y <= 1800)
		return TOWN_BRITAIN;
	elseif (x >= 2200 and x <= 2300 and y >= 1100 and y <= 1250)
		return TOWN_COVE;
	elseif (x >= 1050 and x <= 1525 and y >= 3350 and y <= 4050)
		return TOWN_JHELOM;
	elseif (x >= 3525 and x <= 3825 and y >= 2000 and y <= 2300)
		return TOWN_MAGINCIA;
	elseif (x >= 2400 and x <= 2650 and y >= 2500 and y <= 700)
		return TOWN_MINOC;
	elseif (x >= 4250 and x <= 4725 and y >= 775 and y <= 1525)
		return TOWN_MOONGLOW;
	elseif (x >= 2475 and x <= 3825 and y >= 1025 and y <= 1425)
		return TOWN_NUJELM;
	elseif (x >= 3350 and x <= 3800 and y >= 2350 and y <= 2950)
		return TOWN_OCLLO;
	elseif (x >= 2750 and x <= 3075 and y >= 3325 and y <= 3650)
		return TOWN_SERPENTS_HOLD;
	elseif (x >= 530 and x <= 2250 and y >= 2100 and y <= 600)
		return TOWN_SKARA_BRAE;
	elseif (x >= 1800 and x <= 2150 and y >= 2625 and y <= 2950)
		return TOWN_TRINSIC;
	elseif (x >= 2750 and x <= 3050 and y >= 600 and y <= 1020)
		return TOWN_VESPER;
	elseif (x >= 250 and x <= 750 and y >= 750 and y <= 1250)
		return TOWN_YEW;
	endif
	return 0;
endfunction




///////////////////
//  Finds the town that a given NPC is located in
///////////////////

function FindMyTown (npc)
	return FindTownFromLocation (npc.x, npc.y);
endfunction




///////////////////
//  Determines the naclient of a town from its number
///////////////////

function GetNaclientOfTown (townnum)
	case (townnum)
		TOWN_BRITAIN:
			return "Britain";
		TOWN_COVE:
			return "Cove";
		TOWN_JHELOM:
			return "Jhelom";
		TOWN_MAGINCIA:
			return "Magincia";
		TOWN_MINOC:
			return "Minoc";
		TOWN_MOONGLOW:
			return "Moonglow";
		TOWN_NUJELM:
			return "Nujel'M";
		TOWN_OCLLO:
			return "Ocllo";
		TOWN_SERPENTS_HOLD:
			return "Serpent's Hold";
		TOWN_SKARA_BRAE:
			return "Skara Brae";
		TOWN_TRINSIC:
			return "Trinsic";
		TOWN_VESPER:
			return "Vesper";
		TOWN_YEW:
			return "Yew";
		default:
			return "";
	endcase
	return "";
endfunction


function FindLocation(Client)
  if(client.x>=1244 && client.y>=1530 && client.x<=1704 && client.y<=1758)
    return "Britain";
  elseif(client.x>=4379 && client.y>=1045 && client.x<=4487 && client.y<=1178)
    return "Moonglow";
  elseif(client.x>=5137 && client.y>=3948 && client.x<=5196 && client.y<=4082)
    return "Delucia";
  elseif(client.x>=5196 && client.y>=3923 && client.x<=5322 && client.y<=4085)
    return "Delucia";
  elseif(client.x>=5638 && client.y>=3083 && client.x<=5799 && client.y<=3328)
    return "Papua";
  elseif(client.x>=5799 && client.y>=3121 && client.x<=5822 && client.y<=3327)
    return "Papua";
  elseif(client.x>=1294 && client.y>=3664 && client.x<=1506 && client.y<=3886)
    return "Jhelom";
  elseif(client.x>=494 && client.y>=926 && client.x<=600 && client.y<=1034)
    return "Yew";
  elseif(client.x>=590 && client.y>=796 && client.x<=670 && client.y<=886)
    return "Empath Abbey";
  elseif(client.x>=2394 && client.y>=370 && client.x<=2624 && client.y<=632)
    return "Minoc";
  elseif(client.x>=1794 && client.y>=2638 && client.x<=2136 && client.y<=2902)
    return "Trinsic";
  elseif(client.x>=538 && client.y>=2106 && client.x<=686 && client.y<=2274)
    return "Skara Brae";
  elseif(client.x>=3646 && client.y>=2040 && client.x<=3814 && client.y<=2280)
    return "Magincia";
  elseif(client.x>=3588 && client.y>=2446 && client.x<=3762 && client.y<=2690)
    return "Occlo";
  elseif(client.x>=2612 && client.y>=2082 && client.x<=2772 && client.y<=2256)
    return "Buccaneers Den";
  elseif(client.x>=3496 && client.y>=1062 && client.x<=3808 && client.y<=1400)
    return "Nujel'm";
  elseif(client.x>=2794 && client.y>=634 && client.x<=3026 && client.y<=1000)
    return "Vesper";
  elseif(client.x>=2206 && client.y>=1116 && client.x<=2290 && client.y<=1236)
    return "Cove";
  elseif(client.x>=5120 && client.y>=0 && client.x<=5374 && client.y<=254)
    return "Wind";
  elseif(client.x>=1382 && client.y>=3955 && client.x<=1528 && client.y<=4044)
    return "Jhelom";
  endif
  return "the Free World";
endfunction

