use uo;
use os;

function RemoveSerial(byref contestants, serial)
	set_critical(1);
	var i:=1;
	var num_contestants := contestants.size();
	for ( i:=1; i<=num_contestants; i:=i+1 )
		if ( contestants[i] == serial )
			contestants.erase(i);
			break;
		endif
	endfor
	set_critical(0);
endfunction

function SetupContestants(board, contestants)
	set_critical(1);
	foreach serial in contestants
		var mobile := SystemFindObjectBySerial(serial);
		var entry := board.GetEntryPoint();
		SetObjProperty(mobile, "#arena", GetPid());
		//NPCs should already be created inside the arena to prevent
		//them from attacking spectators
		if ( mobile.npctemplate )
			SetObjProperty(mobile, "#ArenaSerial", mobile.serial);
		else
			MoveCharacterToLocation(mobile, entry.x, entry.y, entry.z);
		endif
	endforeach
	set_critical(0);
endfunction

function RemoveContestants(board, contestants)
	set_critical(1);
	foreach serial in contestants
		var mobile := SystemFindObjectBySerial(serial);
		if ( mobile.npctemplate )
			if(GetObjProperty(mobile, "#arena"))
				if ( !mobile.script["tame"] )
					ApplyRawDamage(mobile, 15000);
				endif
			endif
		endif
		board.RemoveFromArena(mobile, 0);
	endforeach
	set_critical(0);
endfunction
