use os;

include "include/attributes";

function process_combat_event(opponent)
/*
//Added to make the npcs smarter.
  foreach mob in ListHostiles(me, 5)
	if((dist(me, mob) < dist(me, opponent)) or (!CheckLineOfSight(me, opponent)) or (!opponent))
		opponent := mob;
		SetOpponent(mob);
		TurnToward(opponent);
	endif
  endforeach
  */

  spellattack(opponent);
  var plevel := Cint(GetObjProperty(me, "poison_level"));
  var rint := RandomInt(8);
  if((GetHp(me) < (GetMaxHP(me) / 2)) && (rint >= 5))
    CastSpell(me, me, "gheal");
  elseif((plevel >= 1) && (rint >= 5))
    CastSpell(me, me, "cure");
  elseif(((GetHp(me) * 100) / GetMaxHp(me)) < flee_point)
    EraseObjProperty(me,"#flees");
    flee(opponent);
  endif
  if((GetHp(me) <= 100) and (GetMana(me) <= 40) and (me.graphic != 0x190) and (getobjproperty(me, "male") == 2))
    me.graphic := 0x190;
    say("*Highly Wounded, the tribal member cannot remain stealthly anymore*");
  elseif((GetHp(me) <= 100) and (GetMana(me) <= 40) and (me.graphic != 0x190) and (getobjproperty(me, "male") == 1))
    me.graphic := 0x191;
    say("*Highly Wounded, the tribal member cannot remain stealthly anymore*");
  endif
endfunction

function process_flee_event(opponent)
  spellattack(opponent);
  if((GetHp(me) < (GetMaxHP(me) / 2)) && (RandomInt(8) >= 3))
    CastSpell(me, me, "gheal");
    return 0;
  endif
  if((GetObjProperty(me, "poison_level") >= 1) && (RandomInt(8) >= 3))
    CastSpell(me, me, "cure");
    return 0;
  endif
  if(((GetHp(me) * 100) / GetMaxHp(me)) >= flee_point)
    return 1;
  endif
endfunction

function spellattack(opponent)
  if(CInt(GetObjProperty(me,"lastbreath")) > ReadGameClock())
    return;
  endif
  if((CheckLineOfSight(me, opponent)) and (dist(me, opponent) <= 15))
    cast_offensive_spell(me, opponent);
    SetObjProperty(me,"lastbreath",CInt(ReadGameClock() and (RandomInt(4) + 4)));
  endif
endfunction

function prepare_for_fight(opponent)
  var saywords := RandomInt(4);
  case (saywords)
    0: say("You wont go out of here alive, outsider!");
    1: say("You shall pay for disturbing me!");
    2: say("Who dare to come into this sacred place?");
    3: say("This place is not for you fool!");
  endcase
  if((!CInt(GetObjProperty(me, "mr"))) and (RandomInt(3) == 2))
    CastSpell(me, me, "reflect");
  endif
  DisableMainEvents();
  EnableCombatEvents();
endfunction

function post_combat()
  var plevel := Cint(GetObjProperty(me, "poison_level"));
  var rint := RandomInt(8);
  if((GetHp(me) < (GetMaxHP(me) / 2)) && (rint >= 5))
    CastSpell(me, me, "gheal");
  elseif((plevel >= 1) && (rint >= 5))
    CastSpell(me, me, "cure");
  endif
  DisableCombatEvents();
  EnableMainEvents();
  SetWarMode(0);
  SetOpponent(0);
  sleep(1);
  look_around();
endfunction
