include "include/attributes";

function process_combat_event(opponent)
  var rint := RandomInt(8);
  var plevel := Cint(GetObjProperty(me, "poison_level"));
  var oldname := getobjproperty(me, "oldname");
  if((GetHp(me) < (GetMaxHP(me) / 2)) && (RandomInt(8) >= 5))
    CastSpell(me, me, "gheal");
  elseif((plevel >= 1) && (rint >= 5))
    CastSpell(me, me, "cure");
  elseif((GetHP(me) <= 70) && (me.graphic == 0xe1))
	me.graphic := me.objtype;
	setname(me, oldname);
	me.color := me.truecolor;
	eraseobjproperty(me, "oldname");
        say("*As death nears the creature is forced back to its human form*");
  else
    spellattack(opponent);
  endif
  if(((GetHp(me) * 100) / GetMaxHp(me)) < flee_point)
    EraseObjProperty(me,"#flees");
  elseif((GetHP(me) <= 70) && (me.graphic == 0xe1))
	  me.graphic := me.objtype;
	  setname(me, oldname);
	  me.color := me.truecolor;
	  eraseobjproperty(me, "oldname");
  say("*As death nears the creature is forced back to its human form*");
  flee(opponent);
  endif
endfunction

function process_flee_event(opponent)
  if((GetHp(me) < (GetMaxHP(me) / 2)) && (RandomInt(8) >= 3))
    CastSpell(me, me, "gheal");
    return 0;
  endif
  var rint := RandomInt(8);
  var plevel := Cint(GetObjProperty(me, "poison_level"));
  if((plevel >= 1) && (rint >= 5))
    CastSpell(me, me, "cure");
    return 0;
  else
    spellattack(opponent);
  endif
  if(((GetHp(me) * 100) / GetMaxHp(me)) >= flee_point)
    return 1;
  endif
endfunction

function spellattack(opponent)
  if(LAST_BREATH > ReadGameClock())
    return;
  elseif((CheckLineOfSight(me, opponent)) and (dist(me, opponent) <= 12))
    cast_offensive_spell(me, opponent);
    LAST_BREATH := Cint(ReadGameClock() + (RandomInt(4) + 4));
  endif
endfunction

function prepare_for_fight(opponent)
  if((!CInt(GetObjProperty(me, "mr"))) and (RandomInt(3) == 2))
    CastSpell(me, me, "reflect");
  elseif((GetHP(me) >= 70) && (me.graphic != 0xe1))
    SetObjProperty(me, "oldname", me.name);
    me.graphic := 0xe1;
    SetName(me,"a werewolf");
    me.color := 1816;
    say("*The figure before you shifts into the form of a dark wolf*");
  endif
  DisableMainEvents();
  EnableCombatEvents();
endfunction

function post_combat()
  var oldname := getobjproperty(me, "oldname");
  me.graphic := me.objtype;
  setname(me, oldname);
  me.color := me.truecolor;
  eraseobjproperty(me, "oldname");
  say("*Bathed in the blood of its enemy the werewolf returns to its human form*");
  if((GetHp(me) < (GetMaxHP(me) / 2)) && (RandomInt(4) >= 2))
    CastSpell(me, me, "gheal");
  endif
  var rint := RandomInt(8);
  var plevel := Cint(GetObjProperty(me, "poison_level"));
  if((plevel >= 1) && (rint >= 5))
    CastSpell(me, me, "cure");
  endif
  DisableCombatEvents();
  EnableMainEvents();
  SetWarMode(0);
  SetOpponent(0);
  sleep(1);
  look_around();
endfunction
