include "include/attributes";
include "include/spellRestrictions";

function process_combat_event(opponent)
  spellattack(opponent);
  var plevel := Cint(GetObjProperty(me, "poison_level"));
  var rint := RandomInt(8);
  if((GetHp(me) < (GetMaxHP(me) / 2)) && (rint >= 5))
    CastSpell(me, me, "gheal");
  endif
  if((plevel >= 1) && (rint >= 5))
    CastSpell(me, me, "cure");
  endif
  if(((GetHp(me) * 100) / GetMaxHp(me)) < flee_point)
    EraseObjProperty(me,"#flees");
    flee(opponent);
  endif
endfunction

function process_flee_event(opponent)
  spellattack(opponent);
  if((GetHp(me) < (GetMaxHP(me) / 2)) && (RandomInt(8) >= 3))
    CastSpell(me, me, "gheal");
    return 0;
  endif
  if((GetObjProperty(me, "poison_level") >= 1) && (RandomInt(8) >= 3))
    CastSpell(me, me, "cure");
    return 0;
  endif
  if(((GetHp(me) * 100) / GetMaxHp(me)) >= flee_point)
    return 1;
  endif
endfunction

function spellattack(opponent)
return specialAttack(me, opponent);
endfunction

function in_combat_event_loop(opponent, loops)
  spellattack(opponent);
  if ( loops > 50 )
	flee(opponent);
	return;
  endif
endfunction

function prepare_for_fight(opponent)
  if (!CInt(GetObjProperty(me, "mr")))
	CastSpell(me,me,"reflect");
  endif
  DisableMainEvents();
  EnableCombatEvents();
endfunction

function post_combat()
  if ( GetHp(me) < (GetStrength(me)-10))
	CastSpell(me,me,"gheal");
  endif
  DisableCombatEvents();
  EnableMainEvents();
  SetWarMode( 0 );
  SetOpponent( 0 );
  summons := 1;
  sleep(1);
  look_around();
endfunction

function specialAttack(npc, opponent)
	var next_shoot := CInt(GetObjProperty(npc, "#NextShoot"));
	if ( next_shoot > ReadGameClock() )
		return 0;
	endif

	var dist2 := Distance(npc, opponent);
	if ( dist2 < 2 || dist2 > 14 )
		return 0;
	elseif ( !CheckLineOfSight(npc, opponent) )
		return 0;
	elseif ( RandomInt(2) != 1 )
		return 0;
	endif

	//AI_Turn(npc, opponent, NETURN_TOWARD);
	npc.frozen := 1;

	PerformAction(npc, 0x6);
	SleepMS(80);
	PrintTextAbove(npc, "*"+npc.name+" spits a ball of fire*");
	PlayMovingEffect(npc, opponent, 0x36d4, 10, 10, 1);

	
	var coord_list := GetPointsOnLine(me.x,me.y, opponent.x,opponent.y);
	foreach coord in coord_list
		if ( _coord_iter == 1 ) // Dont make one where its standing
			continue;
		endif
		var field := CreateItemAtLocation(coord.x, coord.y, npc.z, "FireFieldNS", 1);
		field.SetDuration(2);
		field.setOwner( npc);
		SleepMS(105);
	endforeach

	PlaySoundEffect(opponent, 0x208);

	var base := Cint(((FLAME_STRENGTH * GetHp(me)) / GetMaxHp(me)) / 2);
	var dmg :=  RandomInt(base) + base;

	dmg := checkMagicalDamage(me, opponent, dmg, "fire");

	ApplyRawDamage(opponent, dmg);

	foreach coord in ( GetCoordsInSquare(opponent.x, opponent.y, 3) )
		if ( RandomInt(2) != 1 ) // Don't place a fire field
			continue;
		endif
		case( RandomInt(3) )
			default:
				PlayStationaryEffect(coord.x, coord.y, npc.z, FX_EXPLODE_1, 10, 10, 0);
				break;
			1:
				PlayStationaryEffect(coord.x, coord.y, npc.z, FX_EXPLODE_2, 10, 10, 0);
				break;
			2:
				PlayStationaryEffect(coord.x, coord.y, npc.z, FX_EXPLODE_3, 10, 10, 0);
				break;
		endcase
		var field := CreateItemAtLocation(coord.x, coord.y, opponent.z, "FireFieldNS", 1);
		field.SetDuration(5);
		field.setOwner(npc);
		SleepMS(5);
	endforeach

	npc.frozen := 0;
	SetObjProperty(npc, "#NextShoot", ReadGameClock()+5);
	return 1;
endfunction

function GetCoordsInSquare(mid_x, mid_y, radius)
	var x_row := CInt(mid_x)-CInt(radius);
	var y_col := CInt(mid_y)-CInt(radius);
	var stop_x := CInt(mid_x)+CInt(radius);
	var stop_y := CInt(mid_y)+CInt(radius);

	var point_list := array{};
	var coord := struct{"x", "y"};

	for ( x_row:=(mid_x-radius); x_row<=stop_x; x_row := x_row + 1 )
		for ( y_col:=(mid_y-radius); y_col<=stop_y; y_col := y_col + 1 )
			coord.x := x_row;
			coord.y := y_col;
			point_list.Append(coord);
			SleepMS(2);
		endfor
		SleepMS(2);
	endfor

	return point_list;
endfunction