include "include/attributes";

function process_combat_event(opponent)
  spellattack(opponent);
  var plevel := Cint(GetObjProperty(me, "poison_level"));
  var rint := RandomInt(8);
  if((GetHp(me) < (GetMaxHP(me) / 2)) && (rint >= 5))
    CastSpell(me, me, "gheal");
  endif
  if((plevel >= 1) && (rint >= 5))
    CastSpell(me, me, "cure");
  endif
  if(((GetHp(me) * 100) / GetMaxHp(me)) < flee_point)
    EraseObjProperty(me,"#flees");
    flee(opponent);
  endif
endfunction

function process_flee_event(opponent)
  spellattack(opponent);
  if((GetHp(me) < (GetMaxHP(me) / 2)) && (RandomInt(8) >= 3))
    CastSpell(me, me, "gheal");
    return 0;
  endif
  if((GetObjProperty(me, "poison_level") >= 1) && (RandomInt(8) >= 3))
    CastSpell(me, me, "cure");
    return 0;
  endif
  if(((GetHp(me) * 100) / GetMaxHp(me)) >= flee_point)
    return 1;
  endif
endfunction

function spellattack(opponent)
  if(CInt(GetObjProperty(me,"lastbreath")) > ReadGameClock())
    return;
  endif
  if((CheckLineOfSight(me, opponent)) and (dist(me, opponent) <= 15))
    if(RandomInt(4) == 1)
    	      var base := Cint(((FLAME_STRENGTH * GetHp(me)) / GetMaxHp(me)) / 2);
	      var dmg :=  RandomInt(base) + base;
    	if ( Distance(me, opponent) <= 5 )
		var coordinates := GetPointsOnLine(me.x,me.y, opponent.x,opponent.y);
		PerformAction(me, 12);
		SleepMS(1100);
		foreach coord in ( coordinates )
			PlayStationaryEffect(coord.x, coord.y, me.z+15, 0x36b0, 15, 15, 0);
		endforeach
	        ApplyRawDamage(opponent, dmg);
	else
	      PerformAction(me,0x0c);
	      PlaySoundEffect(me, 0x16b);
	      sleep(2);
	      PlayMovingEffect(me, opponent, 0x36d4, 10, 1, 1);
	      ApplyRawDamage(opponent, dmg);

	      foreach coord in ( GetCoordsInSquare(opponent.x, opponent.y, 3) )
		if ( RandomInt(2) != 1 ) // Don't place a fire field
			continue;
		endif
		case( RandomInt(3) )
			default:
				PlayStationaryEffect(coord.x, coord.y, me.z, FX_EXPLODE_1, 10, 10, 0);
				break;
			1:
				PlayStationaryEffect(coord.x, coord.y, me.z, FX_EXPLODE_2, 10, 10, 0);
				break;
			2:
				PlayStationaryEffect(coord.x, coord.y, me.z, FX_EXPLODE_3, 10, 10, 0);
				break;
		endcase
		SleepMS(5);
	endforeach

	endif
    else
	  cast_offensive_spell(me,opponent);
    endif
    SetObjProperty(me,"lastbreath",CInt(ReadGameClock() + (RandomInt(4) + 4)));
  endif
endfunction

function in_combat_event_loop(opponent, loops)
  spellattack(opponent);
  if ( loops > 50 )
	flee(opponent);
	return;
  endif
endfunction

function prepare_for_fight(opponent)
  if (!CInt(GetObjProperty(me, "mr")))
	CastSpell(me,me,"reflect");
  endif
  DisableMainEvents();
  EnableCombatEvents();
endfunction

function post_combat()
  if ( GetHp(me) < (GetStrength(me)-10))
	CastSpell(me,me,"gheal");
  endif
  DisableCombatEvents();
  EnableMainEvents();
  SetWarMode( 0 );
  SetOpponent( 0 );
  summons := 1;
  sleep(1);
  look_around();
endfunction

function GetCoordsInSquare(mid_x, mid_y, radius)
	var x_row := CInt(mid_x)-CInt(radius);
	var y_col := CInt(mid_y)-CInt(radius);
	var stop_x := CInt(mid_x)+CInt(radius);
	var stop_y := CInt(mid_y)+CInt(radius);

	var point_list := array{};
	var coord := struct{"x", "y"};

	for ( x_row:=(mid_x-radius); x_row<=stop_x; x_row := x_row + 1 )
		for ( y_col:=(mid_y-radius); y_col<=stop_y; y_col := y_col + 1 )
			coord.x := x_row;
			coord.y := y_col;
			point_list.Append(coord);
			SleepMS(2);
		endfor
		SleepMS(2);
	endfor

	return point_list;
endfunction