/**
 * ( areacheck.inc )
 *
 * Small utility that checks if a character is in a specific location.
 * Returns 1 if the character is in this location with the property set to 1,
 * and 0 if not in that area or the property is not set to 1.
 *
 * character	- The character to check.
 * property	- Check for this property.
 *
 * by shaDoze, 2003
 * Designed for Neverlands, POL 0.95
 *
 * Email: shadoze@gmx.net
 * Last revision: 31 december 2003.
 */

use uo;
use os;
use cfgfile;
use util;

function AreaCheck( character, property )

	var element, rect, prop;
	var cfgfile := ReadConfigFile( "::customregions" );
	var entries := GetConfigStringKeys( cfgfile );

	foreach listing in entries
		element	:= cfgfile[listing];
		rect	:= element.Range;
		rect	:= SplitWords( rect );

		if((character.x >= CInt(rect[1])) && (character.x <= CInt(rect[3])) && (character.y >= CInt(rect[2])) && (character.y <= CInt(rect[4])))
			prop := GetConfigString( element, property );
			if( CInt( prop ) == 1 )
				return 1;
			else
				return 0;
			endif
			break;
		endif
	endforeach

	return 0;

endfunction 