
function info(who, character, trg)
  var online := 0;
  foreach char in EnumerateOnlineCharacters()
    if(char.serial == character)
      character := char;
      online := 1;
    endif
  endforeach
  if(online == 0)
    character := SystemFindObjectBySerial(character, SYSFIND_SEARCH_OFFLINE_MOBILES);
  endif
  if(!character)
     SendSysMessage(who, "That player does not exist. Cancelled.");
  else
    infodata[1] := "Info On: " + character.name;
    FillInStats(character);
    FillInSkills(character);
    FillInWeapon(character);
    var result := SendDialogGump(who, infolayout, infodata);
    var reskey;
    foreach key in(result.keys)
      if(key >= 1000)
        reskey := key;
      endif
    endforeach
    case(result[0])
       1:   //fall through intentional
       2:
       3:
       4:
       5:
       6:
       7:
       9:
      11:
      14:
      13:
      15: EditStat(who, character, result[0], trg);
      16: EditSkill(who, character, reskey-1000, trg);
      17: character.frozen := 1; SendSysMessage(who, character.name + " is frozen.");
      18: character.frozen := 0; SendSysMessage(who, character.name + " is unfrozen.");
      19: if(!character.isA(POLCLASS_NPC))
            SendSysMessage(character, "You were kicked by " + who.name + ".");
            DisconnectClient(character);
          endif
      20: MoveCharacterToLocation(character, 5288, 1176, 0);
      21: if(!character.isA(POLCLASS_NPC))
            var bankbox := FindBankBox(character);
            SendOpenSpecialContainer(who, bankbox);
          else
            SendSysMessage(who, "Only can be used on players.");
          endif
      22: if(!character.isA(POLCLASS_NPC))
            SendOpenSpecialContainer(who, character.backpack);
          else
            SendSysMessage(who, "Only can be used on players.");
          endif
      23: MoveCharacterToLocation(character, who.x, who.y, who.z);
      24: SetName(character, RequestInput(who, who.backpack, "Enter a new name."));
    endcase
  endif
endfunction

function FillInStats(who)
  var levelname;
  case(who.cmdlevel)
      0: levelname := "Player";
      1: levelname := "Trainee";
      2: levelname := "Counselor";
      3: levelname := "Seer";
      4: levelname := "GM";
      5: levelname := "Admin";
      6: levelname := "Development";
  endcase
  infodata[8] := GetStrength(who);
  infodata[10] := GetIntelligence(who);
  infodata[12] := GetDexterity(who);
  infodata[14] := who.x;
  infodata[16] := who.y;
  infodata[18] := who.z;
  infodata[20] := GetHp(who) + "/" + GetMaxHp(who);
  infodata[22] := GetMana(who) + "/" + GetMaxMana(who);
  infodata[24] := GetStamina(who) + "/" + GetMaxStamina(who);
  infodata[26] := who.ar;
  infodata[28] := who.graphic;
  infodata[30] := who.color;
  infodata[144] := levelname;
  infodata[146] := who.acctname;
endfunction

function FillInSkills(who)
  var datindx;
  var skillindx := 0;
  for(datindx := 32; datindx <= 128; datindx := datindx + 2)
    infodata[datindx] := GetEffectiveSkill(who, skillindx);
    skillindx := skillindx + 1;
   endfor
endfunction

function FillInWeapon(who)
  var weapfile := ReadConfigFile(":combat:itemdesc");
  var npcfile := ReadConfigFile("::npcdesc");
  if(who.weapon)
    var idx := find(who.weapon.name, "[", 1); //ignore maker's mark
    if(idx!=0)
      var tempn := who.weapon.desc;
      tempn := tempn[1,idx-1];
      infodata[138] := tempn;
    else
      if(who.weapon.desc == "nodraw")
        infodata[138] := "Wrestling";
      else
        infodata[138] := who.weapon.desc;
      endif
    endif
    var dam := weapfile[who.weapon.objtype].Damage;
    if(!dam)
      infodata[140] := "n/a";
    else
      infodata[140] := dam;
    endif
    infodata[142] := who.weapon.hp + " / " + who.weapon.maxhp;
   else
    infodata[138] := "n/a";
    infodata[140] := "n/a";
    infodata[142] := "n/a";
    if(who.isA(POLCLASS_NPC)) //Hi, i'm an NPC
      var dam := npcfile[who.npctemplate].AttackDamage;
      var weap := npcfile[who.npctemplate].AttackSkillId;
      var ar := npcfile[who.npctemplate].AR;
      if(weap)
        infodata[138] := weap;
      endif
      if(dam)
        infodata[140] := dam;
      endif
      if(ar)
        infodata[142] := "AR: " + ar;
      endif
    endif
  endif
endfunction

function EditStat(who, character, result, trg:=0)
    SendSysMessage(who, "Caution! Values are changed immediately, Integers only!. Hit ESC to cancel.");
    var val := CInt(RequestInput(who, who.backpack, "Enter a new value."));
    if(!val)
      SendSysMessage(who, "Cancelled.");
    else
      case(result)
         1: SetBaseStrength(character,val);
	 	    var logs:=CDateStr(polcore().systime)+ " - " +CTimeStr(polcore().systime) + " Str \t";
		logs:=logs + character.name + " ("+character.acctname+ ") " + + " >>> " + val +"\t"; 
		LogIt(who.acctname, logs, "charprops");
         2: SetBaseIntelligence(character,val);
	 	    var logs:=CDateStr(polcore().systime)+ " - " +CTimeStr(polcore().systime) + " Int \t";
		logs:=logs + character.name + " ("+character.acctname+ ") " + + " >>> " + val +"\t"; 
		LogIt(who.acctname, logs, "charprops");
         3: SetBaseDexterity(character,val);
	 	    var logs:=CDateStr(polcore().systime)+ " - " +CTimeStr(polcore().systime) + " Dex \t";
		logs:=logs + character.name + " ("+character.acctname+ ") " + + " >>> " + val +"\t"; 
		LogIt(who.acctname, logs, "charprops");
         4: MoveCharacterToLocation(character, val, character.y, character.z);
         5: MoveCharacterToLocation(character, character.x, val, character.z);
         6: MoveCharacterToLocation(character, character.x, character.y, val);
         7: SetHp(character, val);
         9: SetMana(character, val);
        11: SetStamina(character, val);
        13: character.ar_mod := 0;
            character.ar_mod := val - character.ar;
        14: character.graphic := val;
	    var logs:=CDateStr(polcore().systime)+ " - " +CTimeStr(polcore().systime) + " Graphic \t";
		logs:=logs + character.name + " ("+character.acctname+ ") " + + " >>> " + val +"\t"; 
		LogIt(who.acctname, logs, "charprops");

        15: character.color := val;
	    var logs:=CDateStr(polcore().systime)+ " - " +CTimeStr(polcore().systime) + " Color   \t";
		logs:=logs + character.name + " ("+character.acctname+ ") " + + " >>> " + val +"\t"; 
		LogIt(who.acctname, logs, "charprops");

      endcase
    endif
endfunction

function EditSkill(who, character, skill, trg:=0);
    SendSysMessage(who, "Caution! Values are changed immediately, Integers only!. Hit ESC to cancel.");
    var val := CInt(RequestInput(who, who.backpack, "Enter a new value.")) * 10;
    if((!val) &&(val != 0))
      SendSysMessage(who, "Cancelled.");
    else
      SetBaseSkillBaseValue(character, skill, val);
      	    var logs:=CDateStr(polcore().systime)+ " - " +CTimeStr(polcore().systime) + " Skill " + skill + " \t";
		logs:=logs + character.name + " ("+character.acctname+ ") " + + " >>> " + val +"\t"; 
		LogIt(who.acctname, logs, "charprops");

    endif
endfunction

///////////////////////////////////
// end info functions
///////////////////////////////////



function editjail(who, trg);
  var val := CInt(SendTextEntryGump(who, "Days? No Max.", 40));
  var logs:=CDateStr(polcore().systime)+ " - " +CTimeStr(polcore().systime) + " EditJail \t";
    logs:=logs + trg.name + "\t" + val; 
    LogIt(who.acctname, logs, "jail");

  if(!val)
    trg.enable();
    trg.eraseprop("releaseday");
    return;
  else
    trg.setprop("releaseday",(ReadGameClock() + val * 24 * 60 * 60));
  endif
endfunction

function ban(who, acctname);
  var banverify := SendDialogGump(who, banlayout, bandata);
  var act := FindAccount(acctname);
  case(banverify[0])
    1: var characters := EnumerateOnlineCharacters();
    var logs:=CDateStr(polcore().systime)+ " - " +CTimeStr(polcore().systime) + " Ban    \t";
    logs:=logs + acctname; 
    LogIt(who.acctname, logs, "jail");

       foreach char in characters
         if(char.acctname == acctname)
           SendSysMessage(char, "You were kicked by " + who.name + ".");
           SetObjProperty(char,"justbanned", 1);
           DisconnectClient(char);
           break;
         endif
       endforeach
       foreach chr in characters
         if(chr.cmdlevel > 1)
           SendSysMessage(chr, "account " + acctname + " has been banned.");
         endif
       endforeach
       Detach();
       sleep(10);
       act.ban();
	   var x, i;
       WipeBankBox(act.GetCharacter(1));
	   for(i := 1; i <= 25; i := i + 1)
	     x := GetEquipmentByLayer(act.GetCharacter(1), i);
	     MoveItemToContainer(x, act.GetCharacter(1).backpack);
	   endfor
       DestroyItem(act.GetCharacter(1).backpack);
       act.DeleteCharacter(1);
       i := 0;
       WipeBankBox(act.GetCharacter(2));
	   for(i := 1; i <= 25; i := i + 1)
	     x := GetEquipmentByLayer(act.GetCharacter(2), i);
	     MoveItemToContainer(x, act.GetCharacter(2).backpack);
	   endfor
       DestroyItem(act.GetCharacter(2).backpack);
       act.DeleteCharacter(2);
       i := 0;
       WipeBankBox(act.GetCharacter(3));
	   for(i := 1; i <= 25; i := i + 1)
	     x := GetEquipmentByLayer(act.GetCharacter(3), i);
	     MoveItemToContainer(x, act.GetCharacter(3).backpack);
	   endfor
       DestroyItem(act.GetCharacter(3).backpack);
       act.DeleteCharacter(3);
       i := 0;
       WipeBankBox(act.GetCharacter(4));
	   for(i := 1; i <= 25; i := i + 1)
	     x := GetEquipmentByLayer(act.GetCharacter(4), i);
	     MoveItemToContainer(x, act.GetCharacter(4).backpack);
	   endfor
       DestroyItem(act.GetCharacter(4).backpack);
       act.DeleteCharacter(4);
       i := 0;
       WipeBankBox(act.GetCharacter(5));
	   for(i := 1; i <= 24; i := i + 1)
	     x := GetEquipmentByLayer(act.GetCharacter(5), i);
	     MoveItemToContainer(x, act.GetCharacter(5).backpack);
	   endfor
       DestroyItem(act.GetCharacter(5).backpack);
       act.DeleteCharacter(5);
    2: SendSysMessage(who,"cancelled");
       return;
  endcase
endfunction

function jail(who, acctname);
  var val := CInt(SendTextEntryGump(who, "Days? No Max.", 40));
  var act := FindAccount(acctname);
    var logs:=CDateStr(polcore().systime)+ " - " +CTimeStr(polcore().systime) + " Jail    \t";
    logs:=logs + acctname+ "\t" + val; 
    LogIt(who.acctname, logs, "jail");

  if(!val)
    act.enable();
    act.eraseprop("releaseday");
    return;
  else
    act.setprop("releaseday",(ReadGameClock() + val * 24 * 60 * 60));
  endif
  var characters := EnumerateOnlineCharacters();
  act.disable();
  foreach char in characters
    if(char.acctname == acctname)
      SendSysMessage(char, "You were kicked by " + who.name + ".");
      DisconnectClient(char);
      break;
    endif
  endforeach
endfunction


function Notes(who, acctname, result) // Added by Shinigami
  var note:=result[25];
  note[1, find(note, ": ", 1)+1]:="";
  var subnote;
  var i;
  for(i:=26; i<=36; i:=i+1)
    subnote:=result[i];
    subnote[1, find(subnote, ": ", 1)+1]:="";
    if(subnote!="")
      note:=note+" "+subnote;
    endif
  endfor
  var act:=FindAccount(acctname);
  var list:= file.FindElement("notes");
  if(!list)
    list:= file.CreateElement("notes");
  endif
  list.setprop(acctname,note);

      var logs:=CDateStr(polcore().systime)+ " - " +CTimeStr(polcore().systime) + " \t";
    logs:=logs + acctname + " \t Notes: " + note; 
    LogIt(who.acctname, logs, "notes");

  UnloadDataFile(file);
endfunction
