///////////////////////////////////////////////////////
//     
//
//        INDEX
//     - Check for armor functions
//     - Protection clothes
//     - Resist clothes
//     - Lightining clothes and mana
//     - Fire clothes and mana
//     - Mana clothes and reset function
//     - HP clothes and reset function	
//     - Main mageclothing creation function
//     - Utility functions
//
///////////////////////////////////////////////////////


////********CHECK FOR ARMOR (NORMAL OR LEATHER)********
function checkforarmor(cast_on)
	
	var cfg := readconfigfile(":combat:itemdesc");
	var item;

	var staffarray := {0x0df0, 0x13f9, 0x0e8a, 0x0e81};

	foreach item in ListEquippedItems(cast_on)
		if (item.objtype in staffarray)
			return 0;
      		elseif ((cfg[item.objtype].blockcircle) && 
		(cfg[item.objtype].blockcircle <= 5) 
		&& (!cfg[item.objtype].errortext) or (cfg[item.objtype].hitsound))
                	return 1;
		endif
	endforeach
	
endfunction

function checkforleather(cast_on)
	
	var cfg := readconfigfile(":combat:itemdesc");
	var item;

	var staffarray := {0x0df0, 0x13f9, 0x0e8a, 0x0e81};

	foreach item in ListEquippedItems(cast_on)
		if (item.objtype in staffarray)
			return 0;
      		elseif ((cfg[item.objtype].blockcircle) && 
		(cfg[item.objtype].blockcircle <= 8) 
		&& (!cfg[item.objtype].errortext) or (cfg[item.objtype].hitsound))
                	return 1;
                 endif
	endforeach
	
endfunction


////********PROTECTION CLOTHES********
function protectionclothing (cast_on, mod_amount)
	
	if (checkforleather (cast_on) == 1)
		sendsysmessage (cast_on, "Your protection clothes are inhibited by your equipment!",3,53);
		return (mod_amount);
	endif
	
	var item;
	var protection:= 0;
	var count:=0;
	
	foreach item in ListEquippedItems(cast_on)
		protection:= getobjproperty (item, "protection");
		if (protection !=ERROR)
			count:= count +1;
		endif
		if (count == 1)
						//Yaika'ar) Decreased prot amount by 25%.
			case (protection)
				1: mod_amount:= mod_amount * 1.15; //1.2
			   	sendsysmessage (cast_on, "Your clothing glows!",3,53);
			   	break;
				2: mod_amount:= mod_amount * 1.3; //1.4
			   	sendsysmessage (cast_on, "Your clothing glows!",3,53);
			   	break;
				3: mod_amount:= mod_amount * 1.45; //1.6
			   	sendsysmessage (cast_on, "Your clothing glows!",3,53);
			   	break;
				4: mod_amount:= mod_amount * 1.6; //1.8
			   	sendsysmessage (cast_on, "Your clothing glows!",3,53);
			   	break;
				5: mod_amount:= mod_amount * 1.75; //2.0
				sendsysmessage (cast_on, "Your clothing glows!",3,53);
				break;
			endcase
		endif
	endforeach  
	Return mod_amount; 

endfunction

function protectionclothingduration (cast_on, duration)
	
	if (checkforleather (cast_on) == 1)
		sendsysmessage (cast_on, "Your protection clothes are inhibited by your equipment!",3,53);
		return (duration);
	endif
	
	var item;
	var protection:= 0;
	var count:=0;
	
	foreach item in ListEquippedItems(cast_on)
		protection:= getobjproperty (item, "protection");
		if (protection !=ERROR)
			count:= count +1;
		endif
		if (count == 1)
			case (protection)
				1: duration:= duration * 1.1;
			   	break;
				2: duration:= duration * 1.2;
			   	break;
				3: duration:= duration * 1.3;
			   	break;
				4: duration:= duration * 1.4;
			   	break;
				5: duration:= duration * 1.5;
				break;
			endcase
		endif
	endforeach  
	return duration;

endfunction

function protmana(caster, mana)

	var prot:= 0;
	var item;
	var count:=0;

	foreach item in ListEquippedItems(caster)
		prot:= getobjproperty (item, "protection");
		if (prot !=ERROR)
			count:= count +1;
		endif
		if (count == 1)
				//Yaika'ar) Decreased mana used by a 25%.
		case (prot)			// Changed by DeiviD 
			1: mana:= mana * 1.375;  // (1 + (0.5 * 0.75));	
			   break;		// I removed the Math, as its aways
			2: mana:= mana * 1.75;   // (1 + (1 * 0.75));
			   break;		// the same result... changet it to the
			3: mana:= mana * 2.125;  // (1 + (1.5 * 0.75));
			   break;		// raw numbers, as it saves a small bit
			4: mana:= mana * 2.5;    // (1 + (2 * 0.75));
			   break;		//  of CPU power
			5: mana:= mana * 2.875;  // (1 + (2.5 * 0.75));
			   break;
		endcase
		endif
          
	endforeach  
	Return (mana);  	
endfunction

//Yaika'ar) Disabled resist clothes.

////********RESIST CLOTHES********
function resistclothing (cast_on,halfamt)

	if (checkforarmor (cast_on) == 1)
		return (halfamt);
	endif
	var item;
	var resist:= 0;
	var count:=0;
	
	foreach item in ListEquippedItems(cast_on)
		resist:= getobjproperty (item, "resist");
		if (resist !=ERROR)
			count:= count +1;
		endif
		if (count == 1)
		case (resist)
			1: halfamt:= cint(halfamt/6*5);
			   sendsysmessage (cast_on, "Your clothing glows!",3,53);
			   break;
			2: halfamt:= cint(halfamt/6*4.5);
			   sendsysmessage (cast_on, "Your clothing glows!",3,53);
			   break;
			3: halfamt:= cint(halfamt/6*4);
			   sendsysmessage (cast_on, "Your clothing glows!",3,53);
			   break;
			4: halfamt:= cint(halfamt/6*3.5);
			   sendsysmessage (cast_on, "Your clothing glows!",3,53);
			   break;
			5: halfamt:= cint(halfamt/6*3);
			   sendsysmessage (cast_on, "Your clothing glows!",3,53);
			   break;
		endcase
		endif
          
	endforeach  
	Return (halfamt);  

endfunction


////********LIGHTINING CLOTHES AND MANA********
function lightningclothing (caster, dmg)

	if (checkforarmor (caster) == 1)
		return (dmg);
	endif
	
	var lightning:= 0;
	var itemz;
	var count:=0;
	var old_dmg := dmg;
	var multiplier;
	
	foreach item in ListEquippedItems(caster)
		lightning:= getobjproperty (item, "lightning_clothing");
		if (lightning)
			itemz:=item;
			count:=1;
			break;
		endif
	endforeach  

		if (count)
		lightning:= getobjproperty (itemz, "lightning_clothing");
					//Yaika'ar) Decreased damage multipier to be at max a 30%.
			case (lightning)
			1: multiplier := 1.05 * skill_adjust_cloth(lightning, SKILLID_EVALINT, caster); //1.3
			   sendsysmessage (caster, "Your clothing glows!",3,53);
			   dmg:=cint(dmg*multiplier);
			   break;
			2: multiplier := 1.1 * skill_adjust_cloth(lightning, SKILLID_EVALINT, caster); //1.5
               sendsysmessage (caster, "Your clothing glows!",3,53);
			   dmg:=cint(dmg*multiplier);
			   break;
			3: multiplier := 1.15 * skill_adjust_cloth(lightning, SKILLID_EVALINT, caster); //1.8
			   sendsysmessage (caster, "Your clothing glows!",3,53);
			   dmg:=cint(dmg*multiplier);
			   break;
			4: multiplier := 1.2 * skill_adjust_cloth(lightning, SKILLID_EVALINT, caster); //2.1
			   sendsysmessage (caster, "Your clothing glows!",3,53);
			   dmg:=cint(dmg*multiplier);
			   break;
			5: multiplier := 1.3 * skill_adjust_cloth(lightning, SKILLID_EVALINT, caster); //2.4
			   sendsysmessage (caster, "Your clothing glows!",3,53);
			   dmg:=cint(dmg*multiplier);
			   break;
		endcase


		endif

	if(dmg < old_dmg)
		dmg := old_dmg;
	endif
	Return (dmg);  	
endfunction

function lightningmana (caster, mana)

	//if (checkforarmor (caster) = 1)
	//	return (dmg);
	//endif
	
	var lightning:= 0;
	var item;
	var count:=0;

	foreach item in ListEquippedItems(caster)
		lightning:= getobjproperty (item, "lightning_clothing");
		if (lightning !=ERROR)
			count:= count +1;
		endif
		if (count == 1)
					//Yaika'ar) Removed mana drain for offensive magic clothes.
		case (lightning)
			1: mana:= mana*1; //1.2;
			   break;
			2: mana:= mana*1; //1.4;
			   break;
			3: mana:= mana*1; //1.6;
			   break;
			4: mana:= mana*1; //1.8;
			   break;
			5: mana:= mana*1; //2;
			   break;
		endcase
		endif
          
	endforeach  
	Return (mana);  	
endfunction


////********FIRE CLOTHES AND MANA********
function fireclothing (caster, dmg)

	if (checkforarmor (caster) == 1)
		return (dmg);
	endif
	
	var fire:= 0;
	var itemz;
	var count:=0;
	var old_dmg := dmg;
	var multiplier;
	
	foreach item in ListEquippedItems(caster)
		fire:= getobjproperty (item, "fire_clothing");
		if (fire)
			itemz:=item;
			count:=1;
			break;
		endif		
	endforeach 

		if (count)
					//Yaika'ar) Decreased damage multipier, to be at max a 30%.
			fire:= getobjproperty (itemz, "fire_clothing");
			case (fire)
				1: multiplier := 1.05 * skill_adjust_cloth(fire, SKILLID_EVALINT, caster); //1.3
				   sendsysmessage (caster, "Your clothing glows!",3,53);
				   dmg:=cint(dmg*multiplier);	
				   break;
				2: multiplier := 1.1 * skill_adjust_cloth(fire, SKILLID_EVALINT, caster); //1.5
				   sendsysmessage (caster, "Your clothing glows!",3,53);
				   dmg:=cint(dmg*multiplier);	
				   break;
				3: multiplier := 1.15 * skill_adjust_cloth(fire, SKILLID_EVALINT, caster); //1.8
				   sendsysmessage (caster, "Your clothing glows!",3,53);
				   dmg:=cint(dmg*multiplier);	
				   break;
				4: multiplier := 1.2 * skill_adjust_cloth(fire, SKILLID_EVALINT, caster); //2.1
				   sendsysmessage (caster, "Your clothing glows!",3,53);
				   dmg:=cint(dmg*multiplier);	
				   break;
				5: multiplier := 1.3 * skill_adjust_cloth(fire, SKILLID_EVALINT, caster); //2.4
				   sendsysmessage (caster, "Your clothing glows!",3,53);
				   dmg:=cint(dmg*multiplier);	
				   break;
			endcase
		endif

	if(dmg < old_dmg)
		dmg := old_dmg;
	endif

	Return (dmg);    	
endfunction

function firemana (caster, mana)

	//if (checkforarmor (caster) = 1)
	//	return (dmg);
	//endif
	
	var fire:= 0;
	var item;
	var count:=0;
	
	foreach item in ListEquippedItems(caster)
		fire:= getobjproperty (item, "fire_clothing");
		if (fire !=ERROR)
			count:= count +1;
		endif
		if (count == 1)
					//Yaika'ar) Removed mana drain in offensive magic clothes.
		case (fire)
			1: mana:= mana*1; //1.2;
			   break;
			2: mana:= mana*1; //1.4;
			   break;
			3: mana:= mana*1; //1.6;
			   break;
			4: mana:= mana*1; //1.8;
			   break;
			5: mana:= mana*1; //2;
			   break;
		endcase
		endif
          
	endforeach  
	Return (mana);  	
endfunction


////********MANA CLOTHES AND RESET MANA FUNCTION********
function manaregeneration (caster, item)

var count:=0;

	nlsetmanaregenrate( caster );
	
	if (checkforarmor (caster) == 1)
		return;
	endif
	
	var manaregen:= 0;
	manaregen:= getobjproperty (item, "manaregen");
	var mult;
						//Yaika'ar) Decreased regen by 25%
               case (manaregen)
			1: 	mult:=1875; 		// 2500
				break;
			2: 	mult:=3000; 		// 4000
				break;
			3: 	mult:=4125;		// 5500
				break;
			4: 	mult:=5250;		// 7000
				break;
			5: 	mult:=6375;		// 8500
				break;
		endcase
		
		var skill_adj := skill_adjust_cloth(manaregen, SKILLID_MEDITATION, caster);
		SetManaRegenRate(caster, (mult * skill_adj));
		SendSysmessage(caster, "You regenerate mana more easily.", 3 , 48);
		var oldregenrate2 := GetObjProperty( caster, "mana_regen_rate" );

endfunction

function unmanaregeneration (caster, item)

	nlsetmanaregenrate( caster );

endfunction

function nlsetmanaregenrate( character )

	var oldregenrate := GetManaRegenRate(character);
	
    SetManaRegenRate(character, CInt( 1200 ));

// Display a message to the character
	if (oldregenrate != GetManaRegenRate(character))
	    if (oldregenrate > GetManaRegenRate(character))
		SendSysmessage(character, "Your mana regeneration becomes inhibited", 3 , 48);
	      else
		SendSysmessage(character, "You regenerate mana more easily.", 3 , 48);
	    endif
	endif

endfunction

////********HP CLOTHES AND RESET HP FUNCTION********
function hpregeneration (caster, item)

var count:=0;


	nlsethpregenrate( caster );
	
	if (checkforarmor (caster) == 1)
		return;
	endif
	
	var hpregen:= 0;
	hpregen:= getobjproperty (item, "hpregen");
	
var oldregenrate := GetObjProperty( caster, "hp_regen_rate" );
								//Yaika'ar) Decreased regen by 25%.
               case (hpregen)
			1: SetHpRegenRate(caster, (1875 * skill_adjust_cloth(hpregen, SKILLID_HEALING, caster))); //2500
		        SendSysmessage(caster, "You regenerate hp more easily.", 3 , 48);
		        var oldregenrate2 := GetObjProperty( caster, "hp_regen_rate" );
			   break;
			2: SetHpRegenRate(caster, (3000 * skill_adjust_cloth(hpregen, SKILLID_HEALING, caster))); //4000
			SendSysmessage(caster, "You regenerate hp more easily.", 3 , 48);
			var oldregenrate2 := GetObjProperty( caster, "hp_regen_rate" );
			   break;
			3: SetHpRegenRate(caster, (4125 * skill_adjust_cloth(hpregen, SKILLID_HEALING, caster))); //5500
			SendSysmessage(caster, "You regenerate hp more easily.", 3 , 48);
			var oldregenrate2 := GetObjProperty( caster, "hp_regen_rate" );
			   break;
			4: SetHpRegenRate(caster, (5250 * skill_adjust_cloth(hpregen, SKILLID_HEALING, caster))); //7000
			SendSysmessage(caster, "You regenerate hp more easily.", 3 , 48);
			var oldregenrate2 := GetObjProperty( caster, "hp_regen_rate" );
			   break;
			5: SetHpRegenRate(caster, (6375 * skill_adjust_cloth(hpregen, SKILLID_HEALING, caster))); //8500
			SendSysmessage(caster, "You regenerate hp more easily.", 3 , 48);
			var oldregenrate2 := GetObjProperty( caster, "hp_regen_rate" );
			   break;
		endcase

endfunction

function unhpregeneration (caster, item)

	nlsethpregenrate( caster );

endfunction

function nlsethpregenrate( character )

        const lowesthprate := 1200;
	var circle:=1;
	var cfg := readconfigfile(":combat:itemdesc");
	var oldregenrate := GetHpRegenRate(character);
	        
        SetHpRegenRate(character,lowesthprate);

// Display a message to the character
	if (oldregenrate != GetHpRegenRate(character))
	    if (oldregenrate > GetHpRegenRate(character))
		SendSysmessage(character, "Your hit points regeneration becomes inhibited", 3 , 48);
	      else
		SendSysmessage(character, "You regenerate hit points more easily.", 3 , 48);
	    endif
	endif

endfunction

////********MAIN MAGECLOTHING CREATION FUNCTION********

function makemageclothing( item )

   	var rndnum:= randomint(5)+1;
   	var numb:= randomint(100);
	var pref;
  	var suffix;
  	var obj;
  	var pricemod := 0;

	case (rndnum)
		1: suffix:= "of Protection";
		obj:= "protection";
		break;
		2: suffix:= "of Mana Regeneration";
		obj:= "manaregen";
		break;	
//		3: suffix:= "of Spell Resistance"; 	//Resist clothes removed.
//		obj:= "resist";
//		break;
		3: suffix:= "of Lightning";
		obj:= "lightning_clothing";
		break;
		4: suffix:= "of Fire";
		obj:= "fire_clothing";
		break;
		5: suffix:= "of Health Regeneration";
		obj:= "hpregen";
		break;
	endcase

   if( numb >= 50 )
       SetObjProperty( item , obj , 1 );
       pref := "Schollar";
       pricemod := 2;
   elseif( numb >= 25 )
       SetObjProperty( item , obj , 2 );
       pref := "Learned";
       pricemod := 3;
   elseif( numb >= 15 )
       SetObjProperty( item , obj , 3 );
       pref := "Seer";
       pricemod := 4;
   elseif( numb >= 5 )
       SetObjProperty( item , obj , 4 );
       pref := "Soothsayer";
       pricemod := 5;
   else
       SetObjProperty( item , obj , 5 );
       pref := "Oracle";
       pricemod := 6;
   endif
   
   	item.buyprice := item.buyprice * pricemod;

	SetObjProperty(item,"prefix",pref);
	SetObjProperty(item,"suffix",suffix);

endfunction

////********UTILITY FUNCTIONS********

function skill_adjust_cloth (level, skill_id, caster)

case(level)
1: level:= 20.0;
   break;
2: level:= 40.0;
   break;
3: level:= 60.0;
   break;
4: level:= 80.0;
   break;
5: level:= 100.0;
   break;
endcase

var skill := cint(GetEffectiveSkill( caster, skill_id ));
if (skill == 0)
	skill := 1;
endif
skill := skill / level;
if (skill > 1)
   skill := 1;
endif
return skill;

endfunction