//
// Sends gump for player to report players for the murder
// and adjusts their murder counts
//
// TODO: ping pong counter
//

use uo;

const STATLOSS_SHORTCOUNT:= 4; //hours
const STATLOSS_LONGCOUNT:= 8; //hours

var layout := {

"page 0",
"nodispose",
"noclose",
"nomove",
"gumppic 0 0 206",
"gumppic 43 0 201",
"gumppic 460 0 207",

"gumppic 0 43 202",
"gumppic 43 43 200",
"gumppic 170 43 200",
"gumppic 295 43 200",
"gumppic 335 43 200",
"gumppic 43 170 200",
"gumppic 170 170 200",
"gumppic 295 170 200",
"gumppic 335 170 200",
"gumppic 43 220 200",
"gumppic 170 220 200",
"gumppic 295 220 200",
"gumppic 335 220 200",
"gumppic 460 43 203",

"gumppic 0 340 204",
"gumppic 43 340 233",
"gumppic 460 340 205",

"button 380 345 249 248 1 0 99",

"text 50 20 40 0",
"text 50 50 40 1",
"text 50 70 40 2"

//"checkbox 100 100 210 211 0 10",
//"checkbox 100 200 210 211 1 11",
};

var data := {
"Now is the time for retribution!",
"Check zero or more players to report for your murder",
"and press OKAY."
};

var reportables;

function SendReportGump(who,rept:= 0)
  var check:= zCheckplace(who);
  if(check)
    SendSysMessage(who, "You are in a no-report area");
    return;
  endif
  if(rept)
    reportables := rept;
  else
    reportables := who.reportables;
  endif
  FillInArrays();
  var reportdata := {};
  foreach reportable in(who.reportables)
	reportdata.append(reportable.killer.serial);
  endforeach
  SetObjProperty(who, "ReportMenu", reportdata);
  var ret := SendDialogGump(who,layout,data);
  if(ret == 0)
    return;
  endif
  EraseObjProperty(who, "ReportMenu");
  EraseObjProperty(who, "LoginReport");
  var mob;
  foreach id in (ret.keys)
	if(id >= 10)
	  id := id-9;
	  mob := who.reportables[id];
	  if(!(mob.killer in EnumerateOnlineCharacters()))
	    SetObjProperty(mob.killer, "LoginNotify", who.serial);
	  else
	    AdjustNoto(mob.killer, who);
	  endif
	  AdjustMurderCounts(who, mob.killer);
	endif
  endforeach
  foreach reportable in(who.reportables)
	who.removeReportable(reportable.serial, reportable.gameclock);
  endforeach
endfunction

function FillInArrays()
  var prev_y := 80;
  var prev_x := 40;
  var buttonret := 10;
  layout.append("page 1");
  foreach reportable in reportables
    if(!reportable.killer.cmdlevel)
	  if(buttonret==21)
	    prev_x := 300;
	    prev_y := 80;
	  endif
	  layout.append("checkbox " + CStr(prev_x) + " " + CStr(prev_y+20) + " 210 211 0 " + buttonret);
	  data.append(reportable.killer.name);
	  layout.append("text " + CStr(prev_x+20) + " " + CStr(prev_y+20) + " 40 " + CStr(len(data)-1));
	  prev_y := prev_y+20;
	  buttonret := buttonret+1;
    endif
  endforeach
endfunction


function AdjustMurderCounts(who, killer)

  var counts:= GetObjProperty(killer,"counts");

  if(!counts)
    counts:= struct;
    counts.+ short:= 0;
    counts.+ longc:= 0;
    counts.+ kills:= 0;
    counts.+ points:= 0;
    counts.+ shortdecay:= 0;
    counts.+ longdecay:= 0;
  endif

  var onlinetime:= GetObjProperty(killer,"onlinetimer");

  counts.short:= counts.short + 1;
  counts.longc:= counts.longc + 1;
  counts.kills:= counts.kills + 1;
  counts.points:= counts.points + RankingPoints(who);
  counts.shortdecay:= onlinetime + (STATLOSS_SHORTCOUNT * 60 * 60);
  counts.longdecay:= onlinetime + (STATLOSS_LONGCOUNT * 60 * 60);

  SetObjProperty(killer,"counts",counts);

  if(counts.longc > 4)
    killer.setMurderer(1);
    SendSysMessage(killer,"You are known across the land as a murderer.");
  endif

endfunction


function zCheckplace(me)
 
 If ( me.x>=5488 and me.y>=1541 and me.x<=5664 and me.y<=1793)
  Return "Region Tourny Complex";  
 Elseif ( me.x>=5488 and me.y>=1541 and me.x<=5528 and me.y<=1641)
  Return "Region 1v1";  
 Elseif ( me.x>=5539 and me.y>=1581 and me.x<=5562 and me.y<=1592)
  Return "Region Monster Bash";      
 Elseif ( me.x>=5700 and me.y>=1653 and me.x<=5737 and me.y<=1691)
  Return "Region 10v10";
 Else
  Return 0;
 Endif 
 
Endfunction


function RankingPoints(who)

  var strength:= GetAttribute(who,ATTRIBUTEID_STRENGTH);
  var dexterity:= GetAttribute(who,ATTRIBUTEID_DEXTERITY);
  var intelligence:= GetAttribute(who,ATTRIBUTEID_INTELLIGENCE);
  var tactics:= GetAttribute(who,ATTRIBUTEID_TACTICS);
  var swords:= GetAttribute(who,ATTRIBUTEID_SWORDSMANSHIP);
  var fencing:= GetAttribute(who,ATTRIBUTEID_FENCING);
  var macing:= GetAttribute(who,ATTRIBUTEID_MACEFIGHTING);
  var anatomy:= GetAttribute(who,ATTRIBUTEID_ANATOMY);
  var magery:= GetAttribute(who,ATTRIBUTEID_MAGERY);
  var resistance:= GetAttribute(who,ATTRIBUTEID_MAGICRESISTANCE);
  var evalint:= GetAttribute(who,ATTRIBUTEID_EVALINT);
  var healing:= GetAttribute(who,ATTRIBUTEID_HEALING);

  var level, fighting, magic;

  if((swords > fencing) and (swords > macing))
    fighting:= swords;
  elseif((fencing > swords) and (fencing > macing))
    fighting:= fencing;
  elseif((macing > swords) and (macing > fencing))
    fighting:= macing;
  else
    fighting:= swords;
  endif
 
  fighting:= ((((fighting + tactics) * 0.45) + ((strength + dexterity) * 0.45)) * 0.5) + ((anatomy + healing) * 0.1);
  magic:= ((((magery + resistance) * 0.5) + intelligence) * 0.5) + (evalint * 0.05);
  level:= (fighting + magic) * 0.5;

  return level;

endfunction
