use uo;
use math;

include "include/attributes";

const STATLOSS_COUNTS:= 4;
const STATLOSS_MIN:= 2;
const STATLOSS_MAX:= 6;

function ResPenalties(who)

  var counts:= GetObjProperty(who,"counts");

  if(!counts)
    counts:= struct;
    counts.+ short:= 0;
    counts.+ longc:= 0;
    counts.+ kills:= 0;
    counts.+ points:= 0;
    counts.+ shortdecay:= 0;
    counts.+ longdecay:= 0;
  endif

  counts.+ average:= counts.points / counts.kills;

  if(!counts.short)
    return;
  elseif(counts.short < STATLOSS_COUNTS)
    return;
  endif

  foreach item in ListItemsAtLocation(who.x,who.y,who.z);
    if(GetObjProperty(item,"chaosshrine"))
      SendSysMessage(who,"Chaos resurrects your body afresh.");
      return;
    endif
  endforeach

  var range:= STATLOSS_MAX - STATLOSS_MIN;
  var verdict:= 125 / range;
  var percentage:= STATLOSS_MAX * 0.01;

  while(counts.average > verdict)
    percentage:= percentage - 0.01;
    verdict:= verdict + (125 / range);
  endwhile

  var docked:= array;
  docked.+ strength:= CInt(GetStrength(who) - (GetStrength(who) * percentage));
  docked.+ dexterity:= CInt(GetDexterity(who) - (GetDexterity(who) * percentage));
  docked.+ intelligence:= CInt(GetIntelligence(who) - (GetIntelligence(who) * percentage));


  SetAttributeBaseValue(who,ATTRIBUTEID_STRENGTH,docked.strength * 10);
  SetAttributeBaseValue(who,ATTRIBUTEID_DEXTERITY,docked.dexterity * 10);
  SetAttributeBaseValue(who,ATTRIBUTEID_INTELLIGENCE,docked.intelligence * 10);

  SendSysMessage(who,"Your body pays the price for your sins.");

  counts.short:= counts.short - 1;

  SetObjProperty(who,"counts",counts);

endfunction