use uo;
use os;
use cfgfile;
use util;

const CONST_STATCAP := 225;   // total stat points
const CONST_SKILLCAP := 7000; // total skill cap * 10
var skillscfg := ReadConfigFile(":*:skills");

Function OnSkillAdvance(who, attributeid)
  if(who.isa(POLCLASS_NPC))
    return;
  endif
  var skillid := Cint(GetSkillIdByAttributeId(attributeid));
  calc_stat_cap(who, skillid);
  count_cap(who, attributeid);
EndFunction

function calc_stat_cap(who, skillid)
  var stat := skillscfg[skillid]."DropStat";
  var split := SplitWords(stat);
  print("Stat: " + stat);
  var bs := GetBaseStrength(who);
  var bd := GetBaseDexterity(who);
  var bi := GetBaseIntelligence(who);
  if(bs > 100)
    SetBaseStrength(who, 100);
    bs := 100;
  endif
  if(bd > 100)
    SetBaseDexterity(who, 100);
    bd := 100;
  endif
  if(bi > 100)
    SetBaseIntelligence(who, 100);
    bi := 100;
  endif
  var stattotal := CInt(bs + bi + bd);
  if(stattotal > CONST_STATCAP)
    var loops := 1;
    while(stattotal > CONST_STATCAP)
      if(loops > 5)
        break;
      endif
      if(split[2])
        stat := split[RandomInt(2)+1];
      endif
      case(stat)
        "str": bs := bs - 1;
               SetBaseStrength(who, bs);
        "dex": bd := bd - 1;
               SetBaseDexterity(who, bd);
        "int": bi := bi - 1;
               SetBaseIntelligence(who, bi);
      endcase
      stattotal := Cint(bs + bd + bi);
      loops := loops + 1;
    endwhile
  endif
endfunction

function count_cap(who, attributeid)
  if(GetAttributeBaseValue(who, attributeid) > 1000)
    SetAttributeBaseValue(who, attributeid, 1000);
  endif
  var skillarray := GetObjProperty(who,"SkillArray");
  if(!skillarray)
    skillarray := {};
    foreach thing in GetAttributeIdsWithoutStatIds()
      if(GetAttributeBaseValue(who, thing) > 0)
        skillarray.append(GetSkillIdByAttributeId(thing));
      endif
      sleepms(10);
    endforeach
    SetObjProperty(who,"SkillArray", skillarray);
  endif
  var skill := GetSkillIdByAttributeId(attributeid);
  skillarray := skillindex(skillarray, skill);
  skillarray.append(skill);
  SetObjProperty(who,"SkillArray", skillarray);
  var skilltotal := 0;
  var skillval := 0;
  var check := 0;
  var loops := 0;
  var placeholder, holder, newval, final;
  while(check == 0)
    if(loops >= 6)
      break;
    endif
    skilltotal := 0;
    foreach thing in skillarray
      skilltotal := skilltotal + GetBaseSkillBaseValue(who, thing);
    endforeach
    if(skilltotal > CONST_SKILLCAP)
      foreach entry in skillarray
        if((GetBaseSkillBaseValue(who, entry)  ) > 0)
          holder := CInt(entry);
          break;
        endif
      endforeach
      newval := GetBaseSkillBaseValue(who, holder);
      final := (newval - 1);
      SetBaseSkillBaseValue(who, holder, final);
    else
      check := 1;
    endif
    loops := loops + 1;
  endwhile
  titlecheck(who);
endfunction

function TitleCheck(who)
  print("running title check");
  var current;
  var highskill := Cint(GetObjProperty(who, "HighSkill"));
  var max_skill;
  var holder := "";
  if(highskill)
    max_skill := GetBaseSkillBaseValue(who, highskill);
  else
    max_skill := 0;
  endif
  print("MS: " + max_skill);
  foreach attributeid in GetAttributeIdsWithoutStatIds()
    current := GetAttributeBaseValue(who, attributeid);
    if( current > max_skill )
      max_skill := current;
      holder := GetSkillIdByAttributeId(attributeid);
      print("HO: " + holder);
    endif
  endforeach
  if(holder = "")
    return;
  endif
  print("H: " + holder);
  SetObjProperty(who, "HighSkill", holder);
  if(max_skill >= 300)
    var cfg := ReadConfigFile(":*:skills");
    if(!cfg)
      print("no cfg");
      return;
    endif
    var elem := FindConfigElem(cfg, holder);;
    if( !elem )
      print("no elem");
      return;
    endif
    var title := elem.Title;
    if( title == error )
      print("no title");
      return;
    endif
    title := CStr(title);
    if( len(title) <= 0 )
      print("title < 0");
      return;
    endif
    if( max_skill < 400 )
      title := ", Neophyte " + title;
    elseif( max_skill < 500 )
      title := ", Novice " + title;
    elseif( max_skill < 600 )
      title := ", Apprentice " + title;
    elseif( max_skill < 700 )
      title := ", Journeyman " + title;
    elseif( max_skill < 800 )
      title := ", Expert " + title;
    elseif( max_skill < 900 )
      title := ", Adept " + title;
    elseif( max_skill < 1000 )
      title := ", Master " + title;
    else
      title := ", Grandmaster " + title;
    endif
    who.title_suffix := title;
  endif
endfunction

function skillindex(skillarray, skill)
  var newarray := {};
  foreach thing in skillarray
    if(thing != skill)
      newarray.append(thing);
    endif
  endforeach
  return newarray;
endfunction