use uo;
use os;
use cfgfile;
use util;

include "include/fields";
include "include/attributes";
include "include/client";
include "include/objtype";
include "include/statMod";
include "include/firewall";
include "include/spellAttack";
include "include/dist";
//include "../../pkg/skills/tinkering/magicjewel";
include "include/pvp_balance";
include "include/NL-armour-powers";

var caster;
var precast := 1;
var castUntilTime78 := 15;
var castUntilTime56 := 20;
var castUntilTime34 := 25;
var castUntilTime12 := 30;

var npccfg_sr := ReadConfigFile("::npcdesc");
const EVID_DISCHARGE := 0x123457;

function maincast(parms, delivery, circle, noto, id);

  var cast_on;
  var spellscroll := 0;
  var scroll;

  if(!can_cast(parms[2], circle))
	return 0;
  endif
  if(parms[1] == "#MOB")
    caster := parms[2];
    if(mobspellcast(caster, circle, spellscroll) == 0)
      return 0;
    endif
    cast_on := parms[3];
  elseif (parms[1] == "#scroll")

    spellscroll := 1;
    caster := parms[2];
    EraseObjProperty(caster, "IsMeditating");
    EraseObjProperty(caster, "HealTimer");
    if(spellcast(caster, circle, spellscroll, id) == 0)
      return 0;
    endif
    scroll := parms[3];
    if(!ReserveItem(scroll))
      SendSysMessage(caster,"You lost your concentration.");
      return 0;
    endif
    if(delivery == "notarget")
      cast_on := caster;
      if(!can_cast(caster, circle))
        cast_on := 0;
      endif
    elseif(delivery == "direct")
      if(noto == "helpful")
        cast_on := CanTargetSpell(caster, circle, TGTOPT_HELPFUL + TGTOPT_CHECK_LOS);
	/*
	 * Added so these spells can only be casted on mobiles!
	 * This prevents the bug where all items can have ar_mods!
	 * Below is the same check again! This message aint supposed to be here, but hey!
	 */
        if( !( cast_on.isa( POLCLASS_MOBILE ) ) )
          cast_on := 0;
          SendSysMessage( caster,"You can't cast this spell on items." );
	endif
	// End
      elseif(noto == "neutral")
        cast_on := CanTargetSpell(caster, circle, TGTOPT_CHECK_LOS);
      else
        cast_on := CanTargetSpell(caster, circle, TGTOPT_HARMFUL + TGTOPT_CHECK_LOS);
      endif
      if(!cast_on)
        return 0;
      endif
    elseif(delivery == "indirect")
      cast_on := CanTargetArea(caster, circle);
    else
      return 0;
    endif
  else
    caster := parms;
    EraseObjProperty(caster, "IsMeditating");
    EraseObjProperty(caster, "HealTimer");
    if (spellcast(caster, circle, spellscroll, id) == 0)
      return 0;
    endif
    if(delivery == "notarget")
      cast_on := caster;
      if(!can_cast(caster, circle))
        cast_on := 0;
      endif
    elseif(delivery == "direct")
      if(noto == "helpful")
        cast_on := CanTargetSpell(caster, circle, TGTOPT_HELPFUL + TGTOPT_CHECK_LOS);
	/*
	 * Added so these spells can only be casted on mobiles!
	 */
        if( !( cast_on.isa( POLCLASS_MOBILE ) ) )
          cast_on := 0;
          SendSysMessage( caster,"You can't cast this spell on items." );
	endif
	// End
      elseif(noto == "neutral")
        cast_on := CanTargetSpell(caster, circle, TGTOPT_CHECK_LOS);
      else
        cast_on := CanTargetSpell(caster, circle, TGTOPT_HARMFUL + TGTOPT_CHECK_LOS);
      endif
      if (!cast_on)
        return 0;
      endif
    elseif(delivery == "indirect")
      cast_on := CanTargetArea(caster, circle);
      if (!cast_on)
        return 0;
      endif
    else
      return 0;
    endif
  endif
  if(newusemana(caster, circle, cast_on, delivery) == 0)
    PlaySoundEffect(caster,0x005d);
    PlayObjectCenteredEffect(caster, 0x3735,0x0a, 0x1e);
    return 0;
  endif
  if(spellscroll == 1)
    if(!SubtractAmount(scroll, 1))
      return 0;
    endif
  endif

  var points := getpoints(circle, spellscroll, SKILLID_MAGERY);
  AwardRawSkillPoints(caster, SKILLID_MAGERY, points);

  //Yaika'ar) Added for evalint pasive gains when casting spells.
  var evalintpoints := getevalintpoints(circle, SKILLID_EVALINT); 
  AwardRawSkillPoints(caster, SKILLID_EVALINT, evalintpoints);    
  // JewelCheck(caster,SKILLID_EVALINT,0,0);
  
  //end.

  var newparms := {};
  newparms[1] := caster;
  newparms[2] := cast_on;
  return newparms;
endfunction

function can_cast(who, circle)
  
  var cfg := readconfigfile(":combat:itemdesc");
  if(!cfg)
     SendSysmessage(who, "I cannot find the cfg file!");
  endif
  
  foreach item in ListEquippedItems(who)
     if ((cfg[item.objtype].blockcircle) && (cfg[item.objtype].blockcircle <= circle) && !cfg[item.objtype].errortext) 
	SendSysmessage(who, "Your equipment prevents you from casting this spell!");
        return 0;
     endif
  endforeach
	
  return 1;
endfunction

function getPrecastWearOutTime(caster, circle)
  case (circle)
	1: return  ReadGameClock() + castUntilTime12;
	2: return  ReadGameClock() + castUntilTime12;
	3: return  ReadGameClock() + castUntilTime34;
	4: return  ReadGameClock() + castUntilTime34;
	5: return  ReadGameClock() + castUntilTime56;
	6: return  ReadGameClock() + castUntilTime56;
	7: return  ReadGameClock() + castUntilTime78;
	8: return  ReadGameClock() + castUntilTime78;
	default: return  ReadGameClock() + castUntilTime34;
  endcase

  return  ReadGameClock() + castUntilTime34;
endfunction

function CanTargetSpell(caster, circle, targopt := TGTOPT_CHECK_LOS)
  if(!can_cast(caster, circle))
    return 0;
  endif
  SetObjProperty(caster, "#targetting", 1);  //Yaika'ar) Added to fix the hiding while casting bug (scrolls).
  If(GetObjProperty(caster, "#arena"));
	SetObjProperty(caster, "#lcia", 1);
  endif
 
 //var untilTime;
 //if(!precast)
  //untilTime := getPrecastWearOutTime(caster, circle);
 // SetObjProperty(caster, "#cast_target", Getpid());
 //// var test := start_script(":spells:precasttimer", {caster, circle, Getpid()});
 //endif
  var cast_on := Target(caster, targopt);
 // EraseObjProperty(caster, "#cast_target");
  
  //if(precast == 0 && untilTime < ReadGameClock())
//	SendSysMessage(caster, "The power of your spell is gone");
//	EraseObjProperty(caster, "#targetting");
//	EraseObjProperty(caster, "#lcia");
//	return 0;
//  endif

  EraseObjProperty(caster, "#targetting");
  If(GetObjProperty(caster, "#arena"));
    If(!GetObjProperty(caster, "#lcia"));
      SendSysMessage(caster, "You cant use pre-casted spells in the arena!");
      return 0;
    endif
  endif
    EraseObjProperty(caster, "#lcia");

  if ((cast_on.x > 5541) AND (cast_on.x < 5566) AND (cast_on.y > 1664) AND (cast_on.y < 1679))
      SendSysMessage(caster, "Spells cannot be cast here.");
	  return 0;
  endif

  if(!cast_on)
    return 0;
  endif
  if(cast_on.hidden)
    SendSysMessage(caster,"You can't see that.");
    return 0;
  endif
  if(dist(caster, cast_on) >= 12)
    SendSysMessage(caster, "That is too far away.");
    return 0;
  endif
  if ((caster.cmdlevel < 1) and (caster.hidden == 1))
    caster.hidden := 0;
  endif
  //end of fix.
  return cast_on;
endfunction

function CanTargetArea(caster, circle)
  if (!can_cast(caster, circle))
    return 0;
  endif
  SetObjProperty(caster, "#targetting", 1);  //Yaika'ar) Added to fix the hiding while casting bug (scrolls).
  If(GetObjProperty(caster, "#arena"));
	SetObjProperty(caster, "#lcia", 1);
  endif
/*
  var untilTime;
  if(!precast)
  untilTime := getPrecastWearOutTime(caster, circle);
  SetObjProperty(caster, "#cast_target", CInt(1));
  start_script(":spells:precasttimer", {caster, circle, Getpid()});
  endif
  */
  var cast_loc := TargetCoordinates(caster);
  /*
  EraseObjProperty(caster, "#cast_target");

 if(precast == 0 && untilTime < ReadGameClock())
	SendSysMessage(caster, "The power of your spell is gone");
	EraseObjProperty(caster, "#targetting");
	EraseObjProperty(caster, "#lcia");
	return 0;
  endif
  */
  EraseObjProperty(caster, "#targetting");
  If(GetObjProperty(caster, "#arena"));
    If(!GetObjProperty(caster, "#lcia"));
      SendSysMessage(caster, "You cant use pre-casted spells in the arena!");
      return 0;
    endif
  endif
    EraseObjProperty(caster, "#lcia");

  if ((cast_loc.x > 5541) AND (cast_loc.x < 5566) AND (cast_loc.y > 1664) AND (cast_loc.y < 1679))
      SendSysMessage(caster, "Spells cannot be cast here.");
	  return 0;
  endif

  if (!cast_loc.x)
    return 0;
  endif
  if (!CheckLosAt(caster, cast_loc.x, cast_loc.y, cast_loc.z))
    SendSysMessage(caster, "You can't see that.");
    return 0;
  endif
  if(coordist(caster.x, caster.y, cast_loc.x, cast_loc.y) >= 12)
    SendSysMessage(caster, "That is too far away.");
    return 0;
  endif
  return cast_loc;
endfunction

function Reflected(cast_on)
  var mr := CInt(GetObjProperty(cast_on, "mr"));
  if(mr == 1)
    PlaySoundEffect(cast_on, SFX_SPELL_MAGIC_REFLECTION);
    PlayObjectCenteredEffect(cast_on, FX_CURSE_EFFECT, 10,10);
    SendSysMessage(cast_on, "Your magic reflect spell saved you!");
    if(mr == 1)
      EraseObjProperty(cast_on, "mr");
    elseif(mr == 2)
      var holder, pid;
      var eqp := GetObjProperty(cast_on, "EquipTimers");
      foreach thing in ListEquippedItems(cast_on)
        foreach entry in eqp
          if((thing.serial == entry[1]) and (entry[2] == "ref"))
            holder := GetObjProperty(thing, "pid");
            break;
          endif
        endforeach
      endforeach
      pid := getprocess(holder);
      if(pid)
        var k := struct;
        k.+type := EVID_DISCHARGE;
        pid.sendevent(k);
      else
        EraseObjProperty(cast_on, "mr");
      endif
    endif
    return 1;
  endif
  return 0;
endfunction

/*Yaika'ar.
 *Changed the resist function, so i placed backup in file.
 *
 *function Resisted(circle, caster, cast_on, amt)
 * var magery := CInt(GetEffectiveSkill(caster, SKILLID_MAGERY));
 * var evalint := CInt(GetEffectiveSkill(caster, SKILLID_EVALINT)) * 0.5;
 * var resist := CInt(GetEffectiveSkill(cast_on, SKILLID_MAGICRESISTANCE));
 * var chk1 := (resist / 5);
 * var chk2 := resist - (((magery - 20) / 5) + (circle * 5));
 * if(chk1 < 1)
 *   chk1 := 1;
 * endif
 * if(chk2 < 1)
 *   chk2 := 1;
 * endif
 * var diff := 0;
 * if(chk1 > chk2)
 *   diff := chk1;
 * else
 *   diff := chk2;
 * endif
 * var points := getresistpoints(circle, cast_on, SKILLID_MAGICRESISTANCE);
 * if(cast_on.dead)
 *   return 0;
 * endif
 * if((RandomInt(99) + 1) <= diff)
 *   SendSysMessage(cast_on, "You feel yourself resisting magical energy!");
 *   PlaySoundEffect(cast_on, SFX_SPELL_WEAKEN);
 *   PlayObjectCenteredEffect(cast_on, FX_CURSE_EFFECT, 5,5);
 *   AwardRawSkillPoints(cast_on, SKILLID_MAGICRESISTANCE, points);
 *   amt := (amt * 0.5);
 *   if(amt < 1)
 *     amt := 1;
 *   endif
 * endif
 * amt := resistclothing (cast_on, amt);
 * var modamt := (1 + ((evalint - resist) / 200.0));
 * amt := (amt * modamt);
 * return CInt(amt);
 *endfunction
 */

function Resisted(circle, caster, cast_on, amt)
  var magery := CInt(GetEffectiveSkill(caster, SKILLID_MAGERY));
  var evalint := CInt(GetEffectiveSkill(caster, SKILLID_EVALINT)) * 0.5;
  var resist := CInt(GetEffectiveSkill(cast_on, SKILLID_MAGICRESISTANCE));
  var chk1 := (resist / 5);
  var chk2 := resist - (((magery - 20) / 5) + (circle * 5));
  if(chk1 < 1)
    chk1 := 1;
  endif
  if(chk2 < 1)
    chk2 := 1;
  endif
  var diff := 0;
  if(chk1 > chk2)
    diff := chk1;
  else
    diff := chk2;
  endif
  var points := getresistpoints(circle, cast_on, SKILLID_MAGICRESISTANCE);
  if(cast_on.dead)
    return 0;
  endif
  if((RandomInt(75) + 1) <= diff) //Increased the resist chance...
    SendSysMessage(cast_on, "You feel yourself resisting magical energy!");
    PlaySoundEffect(cast_on, SFX_SPELL_WEAKEN);
    PlayObjectCenteredEffect(cast_on, FX_CURSE_EFFECT, 5,5);
    AwardRawSkillPoints(cast_on, SKILLID_MAGICRESISTANCE, points);
    //... but decreased damage resisted (it was all or middle dmg, no middle term).
    var random := RandomInt(65);
    if(random < ((resist / 2) - (circle * 5))) 
      amt := (amt * 0.7);
    elseif(random < ((resist / 1.4) - (circle * 5)))
      amt := (amt * 0.8);
    else
      amt := (amt * 0.9);
    endif
    if(amt < 1)
      amt := 1;
    endif
  endif
  // Done to remove the resist clothing effect.
  // amt := resistclothing (cast_on, amt); 
  var modamt := (1 + ((evalint - resist) / 200.0));
  amt := (amt * modamt);
  return CInt(amt);
endfunction

function CalcSpellDamage(circle, caster, cast_on)
  var die_string := circle+"d8";
  var dmg := RandomDiceRoll(die_string);
  dmg := dmg + CInt(GetEffectiveSkill(caster, SKILLID_MAGERY)/10);
  if(dmg > (circle * 8))
    dmg := circle * 8;
  endif
  return dmg;
endfunction

function CanTargetThing(caster, circle, targopt := TGTOPT_CHECK_LOS)
  if (!can_cast(caster, circle))
    return 0;
  endif
  SetObjProperty(caster, "#targetting", 1);  //Yaika'ar) Added to fix the hiding while casting bug (scrolls).
  If(GetObjProperty(caster, "#arena"));
	SetObjProperty(caster, "#lcia", 1);
  endif
  /*
  var untilTime;
  if(!precast)
	untilTime := getPrecastWearOutTime(caster, circle);
	SetObjProperty(caster, "#cast_target", CInt(1));
	start_script(":spells:precasttimer", {caster, circle, Getpid()});
  endif
  */
  var cast_on := Target(caster, targopt);
  /*
  EraseObjProperty(caster, "#cast_target");

  if(precast == 0 && untilTime < ReadGameClock())
	SendSysMessage(caster, "The power of your spell is gone");
	EraseObjProperty(caster, "#targetting");
	EraseObjProperty(caster, "#lcia");
	return 0;
  endif
*/
  EraseObjProperty(caster, "#targetting");
  If(GetObjProperty(caster, "#arena"));
    If(!GetObjProperty(caster, "#lcia"));
      SendSysMessage(caster, "You cant use pre-casted spells in the arena!");
      return 0;
    endif
  endif
  EraseObjProperty(caster, "#lcia");

  if ((cast_on.x > 5541) AND (cast_on.x < 5566) AND (cast_on.y > 1664) AND (cast_on.y < 1679))
      SendSysMessage(caster, "Spells cannot be cast here.");
	  return 0;
  endif

  if(!cast_on)
    return;
  endif
  return cast_on;
endfunction

function spellcast(me, circle, scroll, id)
  var spellcfg := ReadConfigFile(":spells:spells");
  var val := SplitWords(spellcfg[id].val);
  var times := CInt(val[1]);
  var slp   := CInt(val[2]);
  var mhp := GetHp(me);
  var umana, diff;
  var n := 1;
  if(scroll == 0)
    case (circle)
      1:   umana :=   4;     diff :=  10;
      2:   umana :=   6;     diff :=  20;
      3:   umana :=   9;     diff :=  30;
      4:   umana :=  11;     diff :=  50;
      5:   umana :=  14;     diff :=  60;
      6:   umana :=  20;     diff :=  70;
      7:   umana :=  40;     diff :=  85;
      8:   umana :=  50;     diff :=  95;
      9:   umana :=  75;     diff := 100;
     10:   umana := 100;     diff := 100;
    endcase
  elseif(scroll == 1)
    case (circle)
      1:   umana :=   4;     diff := 10;
      2:   umana :=   6;     diff := 10;
      3:   umana :=   9;     diff := 10;
      4:   umana :=  11;     diff := 20;
      5:   umana :=  14;     diff := 30;
      6:   umana :=  20;     diff := 50;
      7:   umana :=  40;     diff := 60;
      8:   umana :=  50;     diff := 70;
      9:   umana :=  75;     diff := 85;
     10:   umana := 100;     diff := 95;
    endcase
  else
    return 0;
  endif

	//Devious) Added Maces if staff equipped

  if(mhp > GetHp(me))
    var medit := GetEffectiveSkill(me,SKILLID_MEDITATION);
    var mace  := GetEffectiveSkill(me,SKILLID_MACEFIGHTING);
    var wres  := GetEffectiveSkill(me,SKILLID_WRESTLING);
    var damaged := mhp - GetHp(me);
    var cfg:= ReadConfigFile(":combat:itemdesc");
    var weap:= GetEquipmentByLayer(me,1);
    if(cfg[weap.objtype].Attribute == "Mace")
      if((RandomInt(99)+1) > ((mace / 2) + (medit / 2) - (damaged * 1.3)))
        SendSysMessage(me,"You lost your concentration.");
        PlaySoundEffect(me,0x005d);
        PlayObjectCenteredEffect(me, 0x3735,0x0a, 0x1e);
        me.frozen :=0;
        return 0;
      endif
    else
      if((RandomInt(99)+1) > ((wres / 2) + (medit / 2) - (damaged * 1.3)))
        SendSysMessage(me,"You lost your concentration.");
        PlaySoundEffect(me,0x005d);
        PlayObjectCenteredEffect(me, 0x3735,0x0a, 0x1e);
        me.frozen :=0;
        return 0;
      endif
    endif
  endif

  if (umana > GetMana(me))
    me.frozen :=1;
    PerformAction(me,ANIM_CAST_DIR);
    sleepms(1200);
    me.frozen :=0;
    SendSysMessage(me,"You do not have enough mana to cast that.");
    PlaySoundEffect(me,0x005d);
    PlayObjectCenteredEffect(me, 0x3735,0x0a, 0x1e);
    return 0;
  endif
  if(can_cast(me, circle))
    me.frozen :=1;

    // Yaika'ar. 
    // Added for the spell disruption feature.
    sleepms(600);
    if((mhp > GetHp(me)) && (CInt(GetObjProperty(me, "lastdmgspell")) >= (ReadGameClock() - 1)))
        var medit := GetEffectiveSkill(me,SKILLID_MEDITATION);
	if((RandomInt(99)+1) > (medit / 5) && (circle != 1))
	  for (n:=1; n<=times; n:=n+1)
	    PerformAction(me,ANIM_CAST_DIR);
	    sleepms(900);
	  endfor
	  if(slp)
	    sleepms(slp * 100);
	  endif
	  SendSysMessage(me,"The spell was disrupted.");
          PlaySoundEffect(me,0x005d);
          PlayObjectCenteredEffect(me, 0x3735,0x0a, 0x1e);
          me.frozen :=0;
          return 0;
	endif
    endif
    //end of addition.

    for (n:=1; n<=times; n:=n+1)
      if((mhp > GetHp(me)) && (CInt(GetObjProperty(me, "lastdmgspell")) < (ReadGameClock() - 1)))
        var medit := GetEffectiveSkill(me,SKILLID_MEDITATION);
        var mace  := GetEffectiveSkill(me,SKILLID_MACEFIGHTING);
        var wres  := GetEffectiveSkill(me,SKILLID_WRESTLING);
        var damaged := mhp - GetHp(me);
        var cfg:= ReadConfigFile(":combat:itemdesc");
        var weap:= GetEquipmentByLayer(me,1);
        if(cfg[weap.objtype].Attribute == "Mace")
          if((RandomInt(99)+1) > ((mace / 2) + (medit / 2) - (damaged * 1.3)))
            SendSysMessage(me,"You lost your concentration.");
            PlaySoundEffect(me,0x005d);
            PlayObjectCenteredEffect(me, 0x3735,0x0a, 0x1e);
            me.frozen :=0;
            return 0;
          endif
        else
          if((RandomInt(99)+1) > ((wres / 2) + (medit / 2) - (damaged * 1.3)))
            SendSysMessage(me,"You lost your concentration.");
            PlaySoundEffect(me,0x005d);
            PlayObjectCenteredEffect(me, 0x3735,0x0a, 0x1e);
            me.frozen :=0;
            return 0;
          endif
        endif
      endif

      PerformAction(me,ANIM_CAST_DIR);
      sleepms(900);
    endfor
    if(slp)
      sleepms(slp * 100);
    endif
    me.frozen :=0;
    if (CheckSkill(me,SKILLID_MAGERY, diff, 0))
      return 1;
    else
      SendSysMessage(me,"The spell fizzles.");
      PlaySoundEffect(me,0x005d);
      PlayObjectCenteredEffect(me, 0x3735,0x0a, 0x1e);
      return 0;
    endif
  endif
endfunction

function checkFireDamage(attacker, defender, dmg)
	var power_amount := p_dragon(defender);
		if(!power_amount)
		return dmg;
		elseif(power_amount == 1)
			dmg := dmg * 0.7;
			return dmg;
		elseif(power_amount == 2)
			dmg := dmg * 0.5;
			return dmg;
		endif
endfunction

function checkMagicalDamage(attacker, defender, dmg, type := "normal")
	if(type == "fire")
		var power_amount := p_dragon(defender);
		if(!power_amount)
		elseif(power_amount == 1)
			dmg := dmg * 0.7;
			Sendsysmessage (defender,"Your dragon armor took some fire damage!", 3,53);
			return dmg;
		elseif(power_amount == 2)
			dmg := dmg * 0.5;
			Sendsysmessage (defender,"Your dragon armor took some fire damage!", 3,53);
			return dmg;
		endif
	endif
	
	var power_amount_magic := p_olive(defender);
	if(!power_amount_magic)
	elseif(power_amount_magic == 1)
		if(RandomInt(100) < 10)
			var multipl := CDbl(CDbl((100 - (RandomInt(20) + 10))) / CDbl(100));
			Sendsysmessage (defender,"Your olive armor took some of the magic damage!", 3,53);
			dmg := dmg * multipl;
		endif
		return dmg;
	elseif(power_amount_magic == 2)
		if(RandomInt(100) < 200)
			var multipl := CDbl(CDbl((100-(RandomInt(20) + 30)))/CDbl(100));
			//var multipl := CDbl(0.21);
			print("Multiplier: " + multipl);
			Sendsysmessage (defender,"Your olive armor took some of the magic damage!", 3,53);
			print("dmg before: " + dmg);
			dmg := dmg * multipl;
			print("dmg after: " + dmg);
		endif
		return dmg;
	endif

	return dmg;
endfunction

function newusemana(who, circle, cast_on, delivery)
  if(delivery == "direct")
    if(!CheckLineOfSight(who, cast_on))
      SendSysMessage(who, "You can't see that.");
      return 0;
    endif
  elseif(delivery == "indirect")
    if(!CheckLosAt(who, cast_on.x, cast_on.y, cast_on.z))
      SendSysMessage(who, "You can't see that.");
      return 0;
    endif
  endif
  if(cdist(who.x, who.y, cast_on.x, cast_on.y) > 12)
    var check := 0;
    foreach thing in EnumerateItemsInContainer(who.backpack)
      if(thing == cast_on)
        check := 1;
        break;
      endif
    endforeach
    if(!check)
      SendSysMessage(who,"The target is out of range.");
      return 0;
    endif
  endif
  var umana;
    case (circle)
    1: umana :=  4;
    2: umana :=  6;
    3: umana :=  9;
    4: umana := 11;
    5: umana := 14;
    6: umana := 20;
    7: umana := 40;
    8: umana := 50;
  endcase
  var mana := GetMana(who);
  if(mana >= umana)
	
	  //check if azure armor set and reduce mana
	  if(who.acctname)
		var power_amount := p_azure(who);
		if(!power_amount)
			umana := umana;
		elseif(power_amount == 1)
			if(RandomInt(100) < 10)
				umana := umana * 0.5;
				 Sendsysmessage (who,"Your azure armor fill some of your mana!", 3,53);
			endif
		elseif(power_amount == 2)
			if(RandomInt(100) < 10)
				umana := 0;
				Sendsysmessage (who,"Your azure armor fill some of your mana!", 3,53);
			endif
		endif

	  endif
	  
	  SetMana(who, Cint(mana - umana));
	  return 1;
  else
    SendSysMessage(who,"You do not have enough mana to cast that.");
    return 0;
  endif

endfunction

function mobspellcast(me, circle, scroll)
  var diff, points, umana;
  case(circle)
    1:   diff := 10;     points :=  20;    umana :=   4;
    2:   diff := 20;     points :=  40;    umana :=   6;
    3:   diff := 30;     points :=  80;    umana :=   9;
    4:   diff := 50;     points := 100;    umana :=  11;
    5:   diff := 60;     points := 130;    umana :=  14;
    6:   diff := 70;     points := 160;    umana :=  20;
    7:   diff := 85;     points := 190;    umana :=  40;
    8:   diff := 95;     points := 210;    umana :=  50;
  endcase
  if(umana > GetMana(me))
    return 0;
  endif
  if(can_cast(me, circle))
    if(CheckSkill(me, SKILLID_MAGERY, (diff - 10), points))
      return 1;
    else
      return 0;
    endif
  endif
endfunction

function getpoints(c, scroll, skillid)
  var points;
  var diff;
  if(scroll == 1)
    case(c)
      1:   points :=  10; diff :=  0;
      2:   points :=  20; diff := 10;
      3:   points :=  20; diff := 10;
      4:   points :=  40; diff := 20;
      5:   points :=  60; diff := 30;
      6:   points := 100; diff := 50;
      7:   points := 120; diff := 60;
      8:   points := 140; diff := 70;
    endcase
  else
    case(c)
      1:   points :=  20; diff := 20;
      2:   points :=  40; diff := 40;
      3:   points :=  80; diff := 50;
      4:   points := 100; diff := 60;
      5:   points := 120; diff := 70;
      6:   points := 140; diff := 80;
      7:   points := 160; diff := 90;
      8:   points := 180; diff := 100;
    endcase
  endif
  var skill := GetEffectiveSkill(caster, skillid);
  if(skill > (diff - 20))
    if((skill - diff) <= 5)
      points := points;
    elseif((skill - diff) <= 10)
      points := (points * 3) / 4;
    elseif((skill - diff) <= 15)
      points := points / 2;
    else
      points := 0;
    endif
  endif
  return points;
endfunction

function getresistpoints(c, victim, skillid)
  var points;
  var diff;
  case(c)
    1:   points :=  20; diff := 20;
    2:   points :=  40; diff := 30;
    3:   points :=  80; diff := 40;
    4:   points := 100; diff := 50;
    5:   points := 120; diff := 60;
    6:   points := 140; diff := 70;
    7:   points := 160; diff := 86;
    8:   points := 180; diff := 100;
  endcase
  var skill := GetEffectiveSkill(victim, skillid);
  if(skill > (diff - 20))
    if((skill - diff) <= 5)
      points := points;
    elseif((skill - diff) <= 10)
      points := (points * 3) / 4;
    elseif((skill - diff) <= 15)
      points := points / 2;
    elseif((skill - diff) <= 15)
      points := points / 4;
    else
      points := 0;
    endif
  endif
  return points;
endfunction

function cdist(x1, y1, x2, y2)
  var xd := x1 - x2;
  var yd := y1 - y2;
  if (xd < 0)
    xd := -xd;
  endif
  if (yd < 0)
    yd := -yd;
  endif
  if (xd > yd)
    return xd;
  else
    return yd;
  endif
endfunction

function usemana(who, circle, cast_on)
  if(cast_on.mobile)
    if(!CheckLineOfSight(who, cast_on))
      SendSysMessage(who, "You can't see that.");
      return 0;
    endif
  else
    if(!CheckLosAt(who, cast_on.x, cast_on.y, cast_on.z))
      SendSysMessage(who, "You can't see that.");
      return 0;
    endif
  endif
  if(cdist(who.x, who.y, cast_on.x, cast_on.y) > 12)
    SendSysMessage(who,"The target is out of range.");
    return 0;
  endif
  var umana;
  case (circle)
    1: umana :=   4;
    2: umana :=   6;
    3: umana :=   9;
    4: umana :=  11;
    5: umana :=  14;
    6: umana :=  20;
    7: umana :=  40;
    8: umana :=  50;
    9: umana :=  75;
   10: umana := 100;
  endcase
  var mana := GetMana(who);
  if(mana >= umana)
    SetMana(who, Cint(mana - umana));
    return 1;
  else
    SendSysMessage(who,"You do not have enough mana to cast that.");
    return 0;
  endif
endfunction

//Yaika'ar) Added this function for evalint pasive gains.
function getevalintpoints(c, skillid)
  var points;
  var diff;
  case(c)
    1:   points :=  10; diff := 20;
    2:   points :=  20; diff := 30;
    3:   points :=  30; diff := 40;
    4:   points :=  40; diff := 50;
    5:   points :=  50; diff := 60;
    6:   points :=  60; diff := 70;
    7:   points :=  70; diff := 80;
    8:   points :=  80; diff := 90;
  endcase

  var skill := GetEffectiveSkill(caster, skillid);
  if(skill > (diff - 20))
    if((skill - diff) <= 5)
      points := points;
    elseif((skill - diff) <= 10)
      points := (points * 3) / 4;
    elseif((skill - diff) <= 15)
      points := points / 2;
    else
      points := 0;
    endif
  endif
  return points;
endfunction