use cfgfile;
use os;
use util;
include "include/attributes";

var unique_items_created := {};
var starteqp_cfg;
var template;
var magicspawnchance := 0;
var magicadjustment  := 0;
var making_starting_equipment := 0;

var thecritter;

//Kr) Function to make loot after death.
function MakeLootOnCorpse(corpse,lootgroup,npctemp)
  var npcdesc := ReadConfigFile("::npcdesc");
  var elem := FindConfigElem(npcdesc, npctemp);
  if (corpse.objtype != 0x2006) return 0; endif
//  var mprop := CInt(GetConfigInt(elem, "Magicitemchance"));
//  var madj  := CInt(GetConfigInt(elem, "MagicAdjustment"));


  starteqp_cfg := ReadConfigFile("::nlootgroup");
  if(lootgroup)
    CreateFromGroup(corpse, lootgroup);
  else
    if(elem)
      var lootgroups := GetConfigStringArray(elem, "lootgroup");
      foreach str in lootgroups
        CreateFromGroup(corpse, CInt(str));
      endforeach
	endif
  endif
endfunction

function MakeLootCorpse(corpse, lootgroup)
  var npcdesc := ReadConfigFile("::npcdesc");
  var elem := FindConfigElem(npcdesc, getobjproperty(corpse,"npctemplate"));
  if (!elem) return 0; endif

  thecritter := corpse;
  var mprop := CInt(GetConfigInt(elem, "Magicitemchance"));
  var madj  := CInt(GetConfigInt(elem, "MagicAdjustment"));
  if(mprop)
    magicspawnchance := 1;
  else
    if((corpse.objtype == 0x9e40) || (corpse.objtype == 0xe40))
      magicspawnchance := 1;
    else
      magicspawnchance := 0;
    endif
  endif
  if(madj > 0)
    magicadjustment  := madj;
  else
    if(corpse.objtype == 0xe40)
      case(CInt(GetObjProperty(corpse,"level")))
        1:  magicadjustment :=  0;
        2:  magicadjustment :=  3;
        3:  magicadjustment :=  6;
        4:  magicadjustment :=  9;
        5:  magicadjustment := 12;
      endcase
    else
      magicadjustment := 0;
    endif
  endif
  starteqp_cfg := ReadConfigFile("::nlootgroup");
  if(lootgroup)
    CreateFromGroup(corpse, lootgroup);
  else
    if(elem)
      var lootgroups := GetConfigStringArray(elem, "lootgroup");
      foreach str in lootgroups
        CreateFromGroup(corpse, CInt(str));
      endforeach
	endif
  endif
endfunction

function MakeLoot(corpse, lootgroup)
  var npcdesc := ReadConfigFile("::npcdesc");
  var elem := FindConfigElem(npcdesc, corpse.npctemplate);
  if (!elem) return 0; endif
  if(GetHp(corpse))
    foreach thing in ListEquippedItems(corpse)
      if(thing.objtype == 0xe75)
        corpse := thing;
        break;
      endif
    endforeach
  endif
  thecritter := corpse;
  var mprop := CInt(GetConfigInt(elem, "Magicitemchance"));
  var madj  := CInt(GetConfigInt(elem, "MagicAdjustment"));
  if(mprop)
    magicspawnchance := 1;
  else
    if((corpse.objtype == 0x9e40) || (corpse.objtype == 0xe40))
      magicspawnchance := 1;
    else
      magicspawnchance := 0;
    endif
  endif
  if(madj > 0)
    magicadjustment  := madj;
  else
    if(corpse.objtype == 0xe40)
      case(CInt(GetObjProperty(corpse,"level")))
        1:  magicadjustment :=  0;
        2:  magicadjustment :=  3;
        3:  magicadjustment :=  6;
        4:  magicadjustment :=  9;
        5:  magicadjustment := 12;
      endcase
    else
      magicadjustment := 0;
    endif
  endif
  starteqp_cfg := ReadConfigFile("::nlootgroup");
  if(lootgroup)
    CreateFromGroup(corpse, lootgroup);
  else
    if(elem)
      var lootgroups := GetConfigStringArray(elem, "lootgroup");
      foreach str in lootgroups
        CreateFromGroup(corpse, CInt(str));
      endforeach
	endif
  endif
endfunction

function CreateStartingEquipment(who, skillids)
  making_starting_equipment := 1;
  starteqp_cfg := ReadConfigFile("::starteqp");
  foreach skillid in skillids
    var skillname := GetSkillName(CInt(skillid));
    CreateFromGroup(who.backpack, skillname);
  endforeach
  CreateFromGroup(who.backpack, "all");
endfunction

function CreateFromGroup(who, group)
  if(making_starting_equipment != 1)
	starteqp_cfg := ReadConfigFile("::nlootgroup");
  endif
  var elem := starteqp_cfg[group];
  if(elem)
    foreach str in GetConfigStringArray(elem, "Stack")
      CreateFromStackString(who, str);
    endforeach
    foreach str in GetConfigStringArray(elem, "Item")
      CreateFromItemString(who, str);
    endforeach
    foreach str in GetConfigStringArray(elem, "Random")
      CreateFromRandomString(who, str);
    endforeach
    foreach str in GetConfigStringArray(elem, "Group")
      CreateFromGroup(who, str);
    endforeach
    foreach str in GetConfigStringArray(elem, "Unique")
      CreateFromUniqueString(who, str);
    endforeach
  endif
endfunction

function GetSkillName(skillid)
  var cfg := ReadConfigFile("::skills");
  return cfg[skillid].name;
endfunction

function CreateFromItemString(who, str)
  var params := SplitWords(str);
  var count, objname, color, chance;
  var couleurs := ReadConfigFile("::colors");
  count := RandomDiceRoll(CStr(params[1]));
  if (params[2])
	  params[1] := params[2];
	  params[2] := params[3];
	  params[3] := params[4];
  endif
  if (!count)
    count := 1;
  endif
  objname := params[1];
  if(CInt(params[2]))
    color := CInt(params[2]);
  elseif(params[2] == "-1")
     color := -1;
  elseif (params[2])
    color := 0;
    var colorg := FindConfigElem(couleurs, params[2]);
    if(colorg)
      var str := GetConfigStringArray(colorg, "color");
	  var ar := {};
	  var rndint := RandomInt(len(str)) + 1;
	  ar := SplitWords(str[rndint]);
	  if(len(ar) > 1)
	    if(CInt(ar[2]) > 0)
	      color := RandomInt(CInt(ar[2]) - CInt(ar[1]))+1;
	    else
	      color := CInt(str[RandomInt(len(str))+1]);
	    endif
	  else
            color := CInt(str[RandomInt(len(str))+1]);
	  endif
	  if(color == 1)
	    color := 0;
	  endif
    endif
  endif
  if (!color)
    color := 0;
  endif
  if(CInt(params[3]))
    chance := CInt(params[3]);
  else
    chance := 100;
  endif
  if(CInt(RandomInt(100)+1) <= CInt(chance))
    var i;
    for(i:=1; i<=CInt(count); i:=i+1)
      if (CInt(objname))
        objname := CInt(objname);
      endif
      var item := CreateItemInContainer(who, objname);
      if(color != -1)
	item.color := color;
      endif
      if(making_starting_equipment)
        item.newbie := 1;
        continue;
      endif
      if( (item.graphic in array( 0xdf2, 0xdf3, 0xdf4, 0xdf5, 0x13f9 )) && (magicspawnchance == 1))
        ProcessWand(item);
      endif
    endfor
  endif
endfunction

function ProcessWand(item)
  var amt;
//  case(RandomInt(10) + 1)
  case(10)
    1: amt :=  15;   SetObjProperty(item, "SpellId",  1);   SetObjProperty(item, "damagemod", "of clumsiness");
    2: amt :=  15;   SetObjProperty(item, "SpellId",  3);   SetObjProperty(item, "damagemod", "of feeblemindedness");
    3: amt :=  15;   SetObjProperty(item, "SpellId",  4);   SetObjProperty(item, "damagemod", "of healing");
    4: amt :=  15;   SetObjProperty(item, "SpellId",  8);   SetObjProperty(item, "damagemod", "of weakness");
    5: amt :=  10;   SetObjProperty(item, "SpellId", 12);   SetObjProperty(item, "damagemod", "of harming");
    6: amt :=   5;   SetObjProperty(item, "SpellId", 18);   SetObjProperty(item, "damagemod", "of fireballs");
    7: amt :=   5;   SetObjProperty(item, "SpellId", 29);   SetObjProperty(item, "damagemod", "of greater healing");
    8: amt :=   3;   SetObjProperty(item, "SpellId", 30);   SetObjProperty(item, "damagemod", "of lightning");
    9: amt :=  10;   SetObjProperty(item, "SpellId", 31);   SetObjProperty(item, "damagemod", "of mana draining");
   10: amt := 100;   SetObjProperty(item, "SpellId", 65);   SetObjProperty(item, "damagemod", "of identification");
  endcase
  SetObjProperty(item, "charges", (amt + RandomInt(10)));
  item.usescript := ":wands:magicWands";
  var dsc;
  if(item.objtype == 0x13f9)
    dsc := "gnarled staff";
  else
    dsc := "wand";
  endif
  SetName(item, "a magic " + dsc);
endfunction

function CreateFromRandomString(who, desc)
  var params := SplitWords(desc);
  var amt := Cint(params[1]);
  var count := 1;
  if(amt != 1)
    count := RandomDiceRoll(Cstr(amt + 1));
  endif
  var group := params[2];
  var chance := params[3];
//  print("Params 1: " + params[1] + " Params 2: " + params[2] + " Params 3: " + params[3] + " Params 4: " + params[4]);
  var elem := FindConfigElem(starteqp_cfg, group);
  if(elem == error)
    syslog("Unable to find group " + group);
    return;
  endif
  var items := GetConfigStringArray(elem, "Item");
  if(items == error)
    syslog("Group " + group + " does not contain items!");
    return;
  endif
  if(!chance)
    chance := 100;
  endif
  var rand := RandomInt(99)+1;
//  print("Rand: " + rand + " Chance: " + chance);
  if(CInt(rand) <= CInt(chance))
    if(count > len(items))
      count := len(items);
    endif
//    print("Loot: " + items);
    while(count)
      var n := RandomInt(len(items)) + 1;
      if(items[n])
        CreateFromItemString(who, items[n]);
        if(making_starting_equipment)
          items[n] := "";
        endif
        count := count - 1;
      endif
    endwhile
  endif
endfunction

function CreateFromUniqueString(who, str)
  var params := SplitWords(str);  
  var objtype;
  if (CInt(params[1]))
    objtype := params[1];
  else
    objtype := GetObjtypeByName(params[1]);
  endif
  if(!objtype)
    syslog("Don't know what a " + str + " is");
    return;
  endif
  if(objtype in unique_items_created)
    return;
  endif
  unique_items_created[len(unique_items_created) + 1] := objtype;
  var newstr := "1 " + str;
  CreateFromItemString(who, newstr);
endfunction

function CreateFromStackString(who, str)
  var params := SplitWords(str);
  var count;
  var objname;
  var color;
  var chance;
  count := RandomDiceRoll(CStr(params[1]));
  params[1] := params[2];
  params[2] := params[3];
  params[3] := params[4];
  if (!count)
    count := 1;
  endif
  objname := params[1];
  if(CInt(params[2]))
    color := CInt(params[2]);
  else
    color := 0;
  endif
  if (CInt(params[3]))
    chance := CInt(params[3]);
  else
    chance := 100;
  endif
  var rand := RandomInt(100)+1;
  if(CInt(rand) <= CInt(chance))
    if (CInt(objname))
      objname := CInt(objname);
    endif
    var item := CreateItemInContainer(who, objname, count);
    if(!item)
      syslog("Unable to create " + objname + " on " + who.name + ".");
    endif
    item.color := color;
    if(making_starting_equipment)
      item.newbie := 1;
    endif
  endif
endfunction