
include "include/string";

function CheckToolWear (who, tool, skill)
  var swings := GetObjProperty(tool,"swings");
  if(!swings)
    CreateToolWear(tool);
	swings := GetObjProperty(tool,"swings");
  endif

  swings:=swings-1;

  if(swings <= 0)
    DestroyItem(tool);
    SendSysMessage(who,"your tool broke.");
	return 0;
  endif;

  SetObjProperty(tool,"swings", (swings ));
  RenameToolWear(tool);
  return 1;
endfunction  

function CreateToolWear (tool)
  var swings := 0;
  var name := GetObjProperty(tool, "on");

  var mods := CInt(GetObjProperty(tool, "#dur"));
  var bonus := CInt(GetObjProperty(tool, "#bonus"));

  var modname:="";

  case(mods)
    1: bonus := 10; modname := "a durable " ; break;
    2: bonus := 25; modname := "a substantial " ; break;
    3: bonus := 40; modname := "a massive " ; break;
    4: bonus := 60; modname := "a fortified " ; break;
    5: bonus := 100; modname := "an indestructable " ; break;
  endcase

  swings := 50 + bonus;
  
  SetObjProperty(tool,"swings", swings);

  if(!name)
	name:=tool.name;
	if(!name)
		name:=tool.desc;
	endif
    if(bonus)
      name:=modname+TruncateArticle(name);
	else
      name:=name;
	endif
    SetObjProperty(tool, "on", name);
  endif

  RenameToolWear(tool);
  EraseObjProperty(tool, "#dur");
  EraseObjProperty(tool, "#bonus");
endfunction  

function RenameToolWear (tool)
  var name := GetObjProperty(tool, "on");
  var swings := GetObjProperty(tool,"swings");

  tool.name:= name+" ["+swings+" uses remaining]";
  tool.desc:= name+" ["+swings+" uses remaining]";
endfunction  
